/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ */
/* ʾĿ¼ */
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"DPTR", ٶȽ, MCS51Ƭ */


/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
/* 62256ṩ32KBRAMΪ: 0000H-01FFHΪ̶д, 0200H-7FFFHΪļݻ */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */
#define FILE_DATA_BUF_ADDR		0x0800	/* ⲿRAMļݻʼַ,ȲСһζдݳ */
/* ʾõ62256ֻ32Kֽ,CH374ӳCH374vSectorSizeֽ,ⲿRAMʣ೤ԼΪ30Kֽ */
#define FILE_DATA_BUF_LEN		0x3800	/* ⲿRAMļݻ,ȲСһζдݳ,ҪСCH374vSectorSize0x400 */
/* ׼ʹ˫д,ôҪFILE_DATA_BUF_LEN,ڲַָ,CH374FileReadXCH374FileRead,CH374FileWriteXCH374FileWrite */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#include "..\CH374HF6.H"

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 200 );
		LED_OUT_INACT( );
		CH374DelaymS( 200 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x21;
	TH1 = 0xf3;  /* 24MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

/* ½Ŀ¼,Ŀ¼ѾֱӴ */
/* :   Ŀ¼mCmdParam.Create.mPathName,ļͬ */
/* ״̬: ERR_SUCCESS = Ŀ¼ɹߴĿ¼ɹ,
               ERR_FOUND_NAME = Ѿͬļ,
               ERR_MISS_DIR = ·ЧϼĿ¼,
               ״̬οCH374HF?.H */
UINT8	CreateDirectory( void )
{
	UINT8	i, j;
	UINT16	count;
	UINT32	UpDirCluster;
	PUINT8X	DirXramBuf;
	UINT8 code *DirConstData;
	j = 0xFF;
	for ( i = 0; i != sizeof( mCmdParam.Create.mPathName ); i ++ ) {  /* Ŀ¼· */
		if ( mCmdParam.Create.mPathName[ i ] == 0 ) break;
		if ( mCmdParam.Create.mPathName[ i ] == PATH_SEPAR_CHAR1 || mCmdParam.Create.mPathName[ i ] == PATH_SEPAR_CHAR2 ) j = i;  /* ¼ϼĿ¼ */
	}
	i = ERR_SUCCESS;
	if ( j == 0 || j == 2 && mCmdParam.Create.mPathName[1] == ':' ) UpDirCluster = 0;  /* ڸĿ¼´Ŀ¼ */
	else {
		if ( j != 0xFF ) {  /* ھ·ӦûȡϼĿ¼ʼغ */
			mCmdParam.Create.mPathName[ j ] = 0;
			i = CH374FileOpen( );  /* ϼĿ¼ */
			if ( i == ERR_SUCCESS ) i = ERR_MISS_DIR;  /* ļĿ¼ */
			else if ( i == ERR_OPEN_DIR ) i = ERR_SUCCESS;  /* ɹϼĿ¼ */
			mCmdParam.Create.mPathName[ j ] = PATH_SEPAR_CHAR1;  /* ָĿ¼ָ */
		}
		UpDirCluster = CH374vStartCluster;  /* ϼĿ¼ʼغ */
	}
	if ( i == ERR_SUCCESS ) {  /* ɹȡϼĿ¼ʼغ */
		i = CH374FileOpen( );  /* 򿪱Ŀ¼ */
		if ( i == ERR_SUCCESS ) i = ERR_FOUND_NAME;  /* ļĿ¼ */
		else if ( i == ERR_OPEN_DIR ) i = ERR_SUCCESS;  /* Ŀ¼Ѿ */
		else if ( i == ERR_MISS_FILE ) {  /* Ŀ¼,½ */
			i = CH374FileCreate( );  /* ԴļķĿ¼ */
			if ( i == ERR_SUCCESS ) {
//				if ( &FILE_DATA_BUF[0] == pDISK_BASE_BUF ) CH374DirtyBuffer( );  /* FILE_DATA_BUFpDISK_BASE_BUF̻ */
				DirXramBuf = &FILE_DATA_BUF[0];  /* ļݻ */
				DirConstData = ".          \x10\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x21\x30\x0\x0\x0\x0\x0\x0..         \x10\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x0\x21\x30\x0\x0\x0\x0\x0\x0";
				for ( i = 0x40; i != 0; i -- ) {  /* Ŀ¼ıԪ,ֱָϼĿ¼ */
					*DirXramBuf = *DirConstData;
					DirXramBuf ++;
					DirConstData ++;
				}
				FILE_DATA_BUF[0x1A] = ( (PUINT8I)&CH374vStartCluster )[3];  /* ʼغ */
				FILE_DATA_BUF[0x1B] = ( (PUINT8I)&CH374vStartCluster )[2];
				FILE_DATA_BUF[0x14] = ( (PUINT8I)&CH374vStartCluster )[1];
				FILE_DATA_BUF[0x15] = ( (PUINT8I)&CH374vStartCluster )[0];
//				FILE_DATA_BUF[0x1A] = ( (PUINT8I)&CH374vStartCluster )[0];  /* СLittle-Endianϵͳ,4дǰ4 */
//				FILE_DATA_BUF[0x1B] = ( (PUINT8I)&CH374vStartCluster )[1];
//				FILE_DATA_BUF[0x14] = ( (PUINT8I)&CH374vStartCluster )[2];
//				FILE_DATA_BUF[0x15] = ( (PUINT8I)&CH374vStartCluster )[3];
				FILE_DATA_BUF[0x20+0x1A] = ( (PUINT8I)&UpDirCluster )[3];  /* ϼĿ¼ʼغ */
				FILE_DATA_BUF[0x20+0x1B] = ( (PUINT8I)&UpDirCluster )[2];
				FILE_DATA_BUF[0x20+0x14] = ( (PUINT8I)&UpDirCluster )[1];
				FILE_DATA_BUF[0x20+0x15] = ( (PUINT8I)&UpDirCluster )[0];
//				FILE_DATA_BUF[0x20+0x1A] = ( (PUINT8I)&UpDirCluster )[0];  /* СLittle-Endianϵͳ,4дǰ4 */
//				FILE_DATA_BUF[0x20+0x1B] = ( (PUINT8I)&UpDirCluster )[1];
//				FILE_DATA_BUF[0x20+0x14] = ( (PUINT8I)&UpDirCluster )[2];
//				FILE_DATA_BUF[0x20+0x15] = ( (PUINT8I)&UpDirCluster )[3];
				for ( count = CH374vSectorSize - 0x40; count != 0; count -- ) {  /* Ŀ¼ʣಿ */
					*DirXramBuf = 0;
					DirXramBuf ++;
				}
				mCmdParam.WriteX.mSectorCount = 1;
				mCmdParam.WriteX.mDataBuffer = FILE_DATA_BUF;  /*  */
				i = CH374FileWriteX( );  /* дĿ¼ĵһ */
				if ( i == ERR_SUCCESS ) {
					DirXramBuf = &FILE_DATA_BUF[0];
					for ( i = 0x40; i != 0; i -- ) {  /* Ŀ¼ */
						*DirXramBuf = 0;
						DirXramBuf ++;
					}
					for ( j = 1; j != CH374vSecPerClus; j ++ ) {
//						if ( &FILE_DATA_BUF[0] == pDISK_BASE_BUF ) CH374DirtyBuffer( );  /* FILE_DATA_BUFpDISK_BASE_BUF̻ */
						mCmdParam.WriteX.mSectorCount = 1;
						mCmdParam.WriteX.mDataBuffer = FILE_DATA_BUF;  /*  */
						i = CH374FileWriteX( );  /* Ŀ¼ʣ */
						if ( i != ERR_SUCCESS ) break;
					}
					if ( j == CH374vSecPerClus ) {  /* ɹĿ¼ */
						mCmdParam.Modify.mFileSize = 0;  /* Ŀ¼ĳ0 */
						mCmdParam.Modify.mFileDate = 0xFFFF;
						mCmdParam.Modify.mFileTime = 0xFFFF;
						mCmdParam.Modify.mFileAttr = ATTR_DIRECTORY;  /* Ŀ¼ */
						i = CH374FileModify( );  /* ļϢ޸ΪĿ¼ */
					}
				}
			}
		}
	}
	return( i );
}

main( ) {
	UINT8	i;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH374רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( 1 ) {  /* ѯCH374жϲж״̬,ȴU̲ */
			CH374DelaymS( 50 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) break;  /* 豸򷵻سɹ,CH374DiskConnectͬʱȫֱCH374DiskStatus */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

		for ( i = 0; i < 5; i ++ ) {  /* ȴʱ,5*50mS */
			CH374DelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
		if ( CH374DiskStatus < DISK_CONNECT ) {  /* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;  /* µȴ */
		}
		if ( CH374DiskStatus < DISK_MOUNTED ) {  /* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			continue;  /* µȴ */
		}

#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH374vSectorSize ) {  /* ݻǷ㹻,CH374vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			continue;
		}
#endif

/* ѯ */
//		printf( "DiskSize\n" );
//		i = CH374DiskSize( );
//		mStopIfError( i );
//		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * ( CH374vSectorSize / 512 ) >> 11 ) );  /* ʾΪMBΪλ */
		LED_RUN_ACT( );  /* ʼU */

		printf( "Create Level 1 Directory /YEAR2004 \n" );
		strcpy( mCmdParam.Create.mPathName, "/YEAR2004" );  /* Ŀ¼,Ŀ¼ڸĿ¼ */
		LED_WR_ACT( );  /* д */
		i = CreateDirectory( );  /* ½ߴĿ¼ */
		mStopIfError( i );
/* Ŀ¼½ߴ򿪳ɹ,Ŀ¼½һʾļ */
		printf( "Create New File /YEAR2004/DEMO2004.TXT \n" );
		strcpy( mCmdParam.Create.mPathName, "/YEAR2004/DEMO2004.TXT" );  /* ļ */
		i = CH374FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write some data to file DEMO2004.TXT \n" );
		strcpy( mCmdParam.ByteWrite.mByteBuffer, "ʾ\xd\xa" );
		mCmdParam.ByteWrite.mByteCount = strlen( mCmdParam.ByteWrite.mByteBuffer );  /* ָдֽ,ζдĳȲܳMAX_BYTE_IO */
		i = CH374ByteWrite( );  /* ֽΪλļд,ζдĳȲܳMAX_BYTE_IO */
		mStopIfError( i );
		printf( "Close file DEMO2004.TXT \n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ */
		i = CH374FileClose( );  /* رļ */
		mStopIfError( i );
/* ½Ŀ¼,ǰһĿ¼ȫͬ */
		printf( "Create Level 2 Directory /YEAR2004/MONTH05 \n" );
		strcpy( mCmdParam.Create.mPathName, "/YEAR2004/MONTH05" );  /* Ŀ¼,Ŀ¼YEAR2004Ŀ¼,YEAR2004Ŀ¼ȴ */
		i = CreateDirectory( );  /* ½ߴĿ¼ */
		mStopIfError( i );
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 0;  /* Ŀ¼ҪԶļ */
		i = CH374FileClose( );  /* رĿ¼,Ŀ¼Ҫر,رֻΪ˷ֹ */
		LED_WR_INACT( );
		LED_RUN_INACT( );
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
