/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ */
/* ʾļĿ¼,:޸ļ,ļĴںʱ */
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"DPTR", ٶȽ, MCS51Ƭ */


/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
/* 62256ṩ32KBRAMΪ: 0000H-01FFHΪ̶д, 0200H-7FFFHΪļݻ */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#include "..\CH374HF6.H"

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ,Ӧ滻ΪʵʵĴʩ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 200 );
		LED_OUT_INACT( );
		CH374DelaymS( 200 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x21;
	TH1 = 0xf3;  /* 24MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

/* ޸ָļļ,Cļ޸ΪTXTļ */
/* :   ԭʼļmCmdParam.Open.mPathName */
/* ״̬: ERR_SUCCESS = ޸ļɹ,
               ״̬οCH374HF?.H */
UINT8	RenameFileName( void )
{
	UINT8			i;
	P_FAT_DIR_INFO	mFileDir;
	i = CH374FileOpen( );  /* ļ */
	if ( i == ERR_SUCCESS ) {
		/* ļд... */
		i = CH374FileQuery( );  /* ѯļ,Ա㽫ݵڴ޸ */
		if ( i == ERR_SUCCESS ) {
			mFileDir = (P_FAT_DIR_INFO)( pDISK_BASE_BUF + CH374vFdtOffset );  /* ڴ,ǰFDTʼַ */
			if ( mFileDir -> DIR_Name[8] == 'C' && mFileDir -> DIR_Name[9] == ' ' ) {  /* ļչC */
				mFileDir -> DIR_Name[8] = 'T';  /* ޸ļչΪTXT */
				mFileDir -> DIR_Name[9] = 'X';  /* ͬ޸ļ */
				mFileDir -> DIR_Name[10] = 'T';
			}
/* ½޸ĹݴڴˢµU */
			mCmdParam.Modify.mFileAttr = mFileDir -> DIR_Attr;  /* ׼޸ļ,ʵʱԭֵ */
			mCmdParam.Modify.mFileDate = mCmdParam.Modify.mFileTime = 0xFFFF;  /* ޸ļںʱ */
			mCmdParam.Modify.mFileSize = 0xFFFFFFFF;  /* ޸ļ */
			i = CH374FileModify( );  /* ʵǽڴиո޸Ĺļ */
			if ( i == ERR_SUCCESS ) {
				/* ļд... */
				mCmdParam.Close.mUpdateLen = 0;
				i = CH374FileClose( );  /* رļ */
			}
		}
	}
	return( i );
}

/* С˸ʽݴ,ļϵͳС,MCS51Ǵ,ԲҪת */
UINT16	SwapUINT16( UINT16 d )
{
	return( ( d << 8 ) & 0xFF00 | ( d >> 8 ) & 0xFF );
}

/* Ϊָļôںʱ */
/* :   ԭʼļmCmdParam.Open.mPathName, µĴںʱ: iCreateDate, iCreateTime */
/* ״̬: ERR_SUCCESS = óɹ,
               ״̬οCH374HF?.H */
UINT8	SetFileCreateTime( UINT16 iCreateDate, UINT16 iCreateTime )
{
	UINT8			i;
	P_FAT_DIR_INFO	mFileDir;
	i = CH374FileOpen( );  /* ļ */
	if ( i == ERR_SUCCESS ) {
		/* ļд... */
		i = CH374FileQuery( );  /* ѯļ,Ա㽫ݵڴ޸ */
		if ( i == ERR_SUCCESS ) {
			mFileDir = (P_FAT_DIR_INFO)( pDISK_BASE_BUF + CH374vFdtOffset );  /* ڴ,ǰFDTʼַ */
//			mFileDir -> DIR_CrtTime = iCreateTime;  /* ļʱ,С˸ʽ */
			mFileDir -> DIR_CrtTime = SwapUINT16( iCreateTime );  /* MCS51ƬǴ˸ʽ */
//			mFileDir -> DIR_CrtDate = iCreateDate;  /* ļ,С˸ʽ */
			mFileDir -> DIR_CrtDate = SwapUINT16( iCreateDate );  /* MCS51ƬǴ˸ʽ */

//			mFileDir -> DIR_WrtTime = MAKE_FILE_TIME( ʱ, ,  );  /* ļ޸ʱ */
//			mFileDir -> DIR_LstAccDate = MAKE_FILE_DATE( , ,  );  /* һδȡ */

/* ½޸ĹݴڴˢµU */
			mCmdParam.Modify.mFileAttr = mFileDir -> DIR_Attr;  /* ׼޸ļ,ʵʱԭֵ */
			mCmdParam.Modify.mFileDate = mCmdParam.Modify.mFileTime = 0xFFFF;  /* ޸ļںʱ */
			mCmdParam.Modify.mFileSize = 0xFFFFFFFF;  /* ޸ļ */
			i = CH374FileModify( );  /* ʵǽڴиո޸Ĺļ */
			if ( i == ERR_SUCCESS ) {
				/* ļд... */
				mCmdParam.Close.mUpdateLen = 0;
				i = CH374FileClose( );  /* رļ */
			}
		}
	}
	return( i );
}

main( ) {
	UINT8	i;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( 1 ) {  /* ѯCH374жϲж״̬,ȴU̲ */
			CH374DelaymS( 50 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) break;  /* 豸򷵻سɹ,CH374DiskConnectͬʱȫֱCH374DiskStatus */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

		for ( i = 0; i < 5; i ++ ) {  /* ȴʱ,5*50mS */
			CH374DelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
		if ( CH374DiskStatus < DISK_MOUNTED ) {  /* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			continue;  /* µȴ */
		}

/* ѯ */
//		printf( "DiskSize\n" );
//		i = CH374DiskSize( );
//		mStopIfError( i );
//		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec >> 11 ) );  /* ʾΪMBΪλ */
		LED_RUN_ACT( );  /* ʼU */

		printf( "Open and rename CH374HFT.C to CH374HFT.TXT \n" );
		strcpy( mCmdParam.Open.mPathName, "/CH374HFT.C" );  /* ԭʼļ,ļڸĿ¼ */
		LED_WR_ACT( );  /* д */
		i = RenameFileName( );  /* ޸ļ, Cļ => TXTļ */
		mStopIfError( i );
		printf( "Set file create date & time to 2004.06.08 15:39:20 \n" );
		strcpy( mCmdParam.Open.mPathName, "/CH374HFT.TXT" );  /* ԭʼļ */
		i = SetFileCreateTime( MAKE_FILE_DATE( 2004, 6, 8 ), MAKE_FILE_TIME( 15, 39, 20 ) );  /* Ϊָļôںʱ */
		mStopIfError( i );
		LED_WR_INACT( );
		LED_RUN_INACT( );
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
