/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ */
/* ļʾ, ļʹӶļöӦĳļ
   ע: CH374HF?.Hͷļ޸, mCmdParamϽṹReadBlockWriteBlockĲṹ
*/
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"DPTR", ٶȽ, MCS51Ƭ */

/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
/* 62256ṩ32KBRAMΪ: 0000H-01FFHΪ̶д, 0200H-7FFFHΪļݻ */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH374Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#define MAX_PATH_LEN			    50
#include "CH374HF6.H"

UINT8X	my_buffer[ 0x2000 ];			/* ⲿRAMļݻ */
/* ׼ʹ˫д,ôڲַָ */

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 100 );
		LED_OUT_INACT( );
		CH374DelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
	TMOD = 0x20;
	TH1 = 0xf3;		  /* 24MHz, 9600bps */
	TR1 = 1;
	TI = 1;
}

void    mDelaymS( unsigned char delay )
{
    unsigned char   i, j, c;
    for ( i = delay; i != 0; i -- ) {
        for ( j = 200; j != 0; j -- ) c += 3;  /* 24MHzʱʱ500uS */
        for ( j = 200; j != 0; j -- ) c += 3;  /* 24MHzʱʱ500uS */
    }
}

/*====================ļĺ궨弫ȫֱ =======================*/
// ļ(020)*26
#define     LONG_NAME_BUF_LEN       (20*26)
#define     UNICODE_ENDIAN          1           // 1ΪUNICDOE˱ 0ΪС
// ļŻ(Unicode)
UINT8   xdata LongNameBuf[ LONG_NAME_BUF_LEN ];

#define     TRUE        1
#define     FALSE       0

// 
#define     ERR_NO_NAME             0X44        // ˶ļûгļĳļ
#define     ERR_BUF_OVER            0X45        // ļ
#define     ERR_LONG_NAME           0X46        // ĳļ
#define     ERR_NAME_EXIST          0X47        // ˶ļ
/*============================================================================*/

/*==============================================================================
: CheckNameSum

: 鳤ļĶļ

==============================================================================*/
UINT8 CheckNameSum( UINT8 *p )
{
UINT8 FcbNameLen;
UINT8 Sum;

    Sum = 0;
    for (FcbNameLen=0; FcbNameLen!=11; FcbNameLen++)
        Sum = ((Sum & 1) ? 0x80 : 0) + (Sum >> 1) + *p++;
    return Sum;
}

/*==============================================================================
: AnalyzeLongName

: ļ м26

==============================================================================*/
UINT8 AnalyzeLongName( void )
{
UINT8   i, j;
UINT16  index;

    i = FALSE;
    for( index=0; index!=LONG_NAME_BUF_LEN; index = index + 2 )
    {
        if( ( LongNameBuf[index] == 0 ) && ( LongNameBuf[index+1] == 0 ) )
        {
            i = TRUE;
            break;
        }
    }
    if( ( i == FALSE ) || ( index == 0) )
        return 0;                   // 0ʾĳļ

    i = index % 26;
    if( i != 0 )
    {
        index += 2;
        if( index % 26 != 0 )       // 0պý
        {
            for( j=i+2; j!=26; j++ )// ʣΪ0XFF
                LongNameBuf[index++] = 0xff;
        }
    }
    return  (index / 26);
}

/*==============================================================================
: CH374CreateLongName

: ļ,Ҫļ·

==============================================================================*/
UINT8 CH374CreateLongName( void )
{
//  ļ· һļ õFDTƫƺ ɾļ
// ƫ ʧ FAT12/16ڸĿ¼ Ϻٴδļ
UINT8   i;
UINT8   len;                                // ·ĳ
UINT16  index;                              // ļƫ
UINT16  indexBak;                           // ļƫ
UINT32  Secoffset;                          // ƫ

UINT8   Fbit;                               // һνд
UINT8   Mult;                               // ļ26ı
UINT8   MultBak;                            // ļ26ı

UINT16  Backoffset;                         // ļƫƱ
UINT16  BackoffsetBak;                      // ƫƱݵı
UINT32  BackFdtSector;                      // ƫһ
UINT8   sum;                                // 泤ļУ

UINT8   xdata BackPathBuf[MAX_PATH_LEN];    // ļ·

    Mult = AnalyzeLongName( );              // 泤ļ26ı
    if( Mult == 0 )
        return ERR_LONG_NAME;
    MultBak = Mult;

    i = CH374FileOpen();                    // ļ򷵻ش
    if( i == ERR_SUCCESS )
        return ERR_NAME_EXIST;

    i = CH374FileCreate( );
    if( i == ERR_SUCCESS )
    {
        Backoffset = CH374vFdtOffset;
        BackoffsetBak = Backoffset;
        BackFdtSector = CH374vFdtLba;
        sum = CheckNameSum( &DISK_BASE_BUF[Backoffset ] );
        for( i=0; i!=MAX_PATH_LEN; i++ )    // ļ·б
            BackPathBuf[i] = mCmdParam.Open.mPathName[i];
        CH374FileErase( );                  // ɾļ

        Secoffset   = 0;                    // 0ʼƫ
        index       = Mult*26;              // õļĳ
        indexBak    = index;
        Fbit        = FALSE;                // Ĭûн
        // ϼ 
        P_RETRY:
        for(len=0; len!=MAX_PATH_LEN; len++)
        {
            if(mCmdParam.Open.mPathName[len] == 0)
                break;                      // õַ
        }

        for(i=len-1; i!=0xff; i--)          // õϼĿ¼λ
        {
            if((mCmdParam.Open.mPathName[i] == '\\') || (mCmdParam.Open.mPathName[i] == '/'))
                break;
        }
        mCmdParam.Open.mPathName[i] = 0x00;

        if( i==0 )                          // һĿ¼ע:ڸĿ¼ʼ
        {
            mCmdParam.Open.mPathName[0] = '/';
            mCmdParam.Open.mPathName[1] = 0;
        }

        i = CH374FileOpen();                // ϼĿ¼
        if( i == ERR_OPEN_DIR )
        {
            while( 1 )                      // ѭд ֱ
            {
                mCmdParam.Locate.mSectorOffset = Secoffset;
                i = CH374FileLocate( );
                if( i == ERR_SUCCESS )
                {
                    if( Fbit )             // ڶνд
                    {
                        if( mCmdParam.Locate.mSectorOffset != 0x0FFFFFFFF )
                        {
                            BackFdtSector = mCmdParam.Locate.mSectorOffset;
                            Backoffset = 0;
                        }
                        else
                        {
                            for( i=0; i!=MAX_PATH_LEN; i++ )// ԭļ·
                                mCmdParam.Open.mPathName[i] = BackPathBuf[i];
                            i = CH374FileCreate( );         // пռչ
                            if( i != ERR_SUCCESS )
                                return i;
                            CH374FileErase( );
                            goto P_RETRY;                   // ´ϼĿ¼
                        }
                    }

                    if( BackFdtSector == mCmdParam.Locate.mSectorOffset )
                    {
                        mCmdParam.ReadX.mSectorCount = 1;   // һ̻
                        mCmdParam.ReadX.mDataBuffer = &DISK_BASE_BUF[0];
                        i = CH374FileReadX( );
                        CH374DirtyBuffer( );                // ̻
                        if( i!= ERR_SUCCESS )
                            return i;

                        i = ( CH374vSectorSize - Backoffset ) / 32;
                        if( Mult > i )
                            Mult = Mult - i;                // ʣı
                        else
                        {
                            i = Mult;
                            Mult = 0;
                        }

                        for( len=i; len!=0; len-- )
                        {
                            indexBak -= 26;
                            index = indexBak;
                            for( i=0; i!=5; i++)            // ļ1-5ַ
                            {                               // ڴUNICODEС˷ʽ
                                #if UNICODE_ENDIAN == 1
                                DISK_BASE_BUF[Backoffset + i*2 + 2 ] =
                                    LongNameBuf[index++];
                                DISK_BASE_BUF[Backoffset + i*2 + 1 ] =
                                    LongNameBuf[index++];
                                #else
                                DISK_BASE_BUF[Backoffset + i*2 + 1 ] =
                                    LongNameBuf[index++];
                                DISK_BASE_BUF[Backoffset + i*2 + 2 ] =
                                    LongNameBuf[index++];
                                #endif
                            }

                            for( i =0; i!=6; i++)           // ļ6-11ַ
                            {
                                #if UNICODE_ENDIAN == 1
                                DISK_BASE_BUF[Backoffset + 14 + i*2 + 1 ] =
                                    LongNameBuf[index++];
                                DISK_BASE_BUF[Backoffset + 14 + i*2 ] =
                                    LongNameBuf[index++];
                                #else
                                DISK_BASE_BUF[Backoffset + 14 + i*2 ] =
                                    LongNameBuf[index++];
                                DISK_BASE_BUF[Backoffset + 14 + i*2 + 1 ] =
                                    LongNameBuf[index++];
                                #endif
                            }

                            for( i=0; i!=2; i++)            // ļ12-13ַ
                            {
                                #if UNICODE_ENDIAN == 1
                                DISK_BASE_BUF[Backoffset + 28 + i*2 + 1 ] =
                                    LongNameBuf[index++];
                                DISK_BASE_BUF[Backoffset + 28 + i*2 ] =
                                    LongNameBuf[index++];
                                #else
                                DISK_BASE_BUF[Backoffset + 28 + i*2 ] =
                                    LongNameBuf[index++];
                                DISK_BASE_BUF[Backoffset + 28 + i*2 + 1 ] =
                                    LongNameBuf[index++];
                                #endif
                            }

                            DISK_BASE_BUF[Backoffset + 0x0b] = 0x0f;
                            DISK_BASE_BUF[Backoffset + 0x0c] = 0x00;
                            DISK_BASE_BUF[Backoffset + 0x0d] = sum;
                            DISK_BASE_BUF[Backoffset + 0x1a] = 0x00;
                            DISK_BASE_BUF[Backoffset + 0x1b] = 0x00;
                            DISK_BASE_BUF[Backoffset] = MultBak--;
                            Backoffset += 32;
                        }

                        if( !Fbit )
                        {
                            Fbit = TRUE;
                            DISK_BASE_BUF[ BackoffsetBak ] |= 0x40;
                        }

                        mCmdParam.WriteB.mLbaCount = 1;
                        mCmdParam.WriteB.mLbaStart = BackFdtSector;
                        mCmdParam.WriteB.mDataBuffer = DISK_BASE_BUF;
                        i = CH374WriteBlock();
                        if( i!= ERR_SUCCESS )
                            return i;

                        if( Mult==0 )
                        {                               // ԭļ·
                            for( i=0; i!=MAX_PATH_LEN; i++ )
                                mCmdParam.Open.mPathName[i] = BackPathBuf[i];
                            i = CH374FileCreate( );
                            return i;
                        }
                    }
                }
                else
                    return i;
                Secoffset++;
            }
        }
    }
    return i;
}

/*==============================================================================

: GetUpSectorData

: ɵǰõһݣڴ̻

==============================================================================*/
UINT8 GetUpSectorData( UINT32 *NowSector )
{
UINT8  i;
UINT8  len;             // ·ĳ
UINT32 index;           // Ŀ¼ƫ

    index = 0;
    for(len=0; len!=MAX_PATH_LEN; len++)
    {
        if(mCmdParam.Open.mPathName[len] == 0)          // õַ
            break;
    }

    for(i=len-1; i!=0xff; i--)                          // õϼĿ¼λ
    {
        if((mCmdParam.Open.mPathName[i] == '\\') || (mCmdParam.Open.mPathName[i] == '/'))
            break;
    }
    mCmdParam.Open.mPathName[i] = 0x00;

    if( i==0 )  // һĿ¼ע:ڸĿ¼ʼ
    {
        mCmdParam.Open.mPathName[0] = '/';
        mCmdParam.Open.mPathName[1] = 0;
        i = CH374FileOpen();
        if ( i == ERR_OPEN_DIR )
            goto P_NEXT0;
    }
    else
    {
        i = CH374FileOpen();
        if ( i == ERR_OPEN_DIR )
        {
            while( 1 )
            {
                P_NEXT0:
                mCmdParam.Locate.mSectorOffset = index;
                i = CH374FileLocate( );
                if( i == ERR_SUCCESS )
                {
                    if( *NowSector == mCmdParam.Locate.mSectorOffset )
                    {
                        if( index==0 )                          // ڸĿ¼Ŀʼ
                            return ERR_NO_NAME;
                        mCmdParam.Locate.mSectorOffset = --index;
                        i = CH374FileLocate( );                 // һ
                        if( i == ERR_SUCCESS )
                        {                                       // ±浱ǰ
                            *NowSector = mCmdParam.Locate.mSectorOffset;
                            mCmdParam.ReadX.mSectorCount = 1;   // һ̻
                            mCmdParam.ReadX.mDataBuffer = &DISK_BASE_BUF[0];
                            i = CH374FileReadX( );
                            CH374DirtyBuffer( );                // ̻
                            return i;
                        }
                        else
                            return i;
                    }
                }
                else
                    return i;
                index++;
            }
        }
    }
    return i;
}

/*==============================================================================

: CH374GetLongName

: ļ·(ļļ)õӦĳļ

==============================================================================*/
UINT8 CH374GetLongName( void )
{
// ҪС
// һļǷҵļ,ļǷ,õFDTڴƫƺ
// ڶϢǷгļڣǷĿ¼ĵһĿʼ
// ʵƫһ?ȡļ(512ֽڵU)
UINT8   i;
UINT16  index;          // ڳļڵ
UINT32  BackFdtSector;  // ƫһ
UINT8   sum;            // 泤ļУ
UINT16  Backoffset;     // ļƫƱ
UINT16  offset;         // ļƫ32
UINT8   FirstBit;       // ļԽ־λ
UINT8   xdata BackPathBuf[MAX_PATH_LEN]; // ļ·

    i = CH374FileOpen( );
    if( ( i == ERR_SUCCESS ) || ( i == ERR_OPEN_DIR ) )
    {
        for( i=0; i!=MAX_PATH_LEN; i++ )
            BackPathBuf[i] = mCmdParam.Open.mPathName[i];
        // ɶ·ı

        sum = CheckNameSum( &DISK_BASE_BUF[CH374vFdtOffset] );
        index = 0;
        FirstBit = FALSE;
        Backoffset = CH374vFdtOffset;
        BackFdtSector = CH374vFdtLba;
        if( CH374vFdtOffset == 0 )
        {
            // жǷһʼ ǷڸĿ¼ʼ ƫ
            if( FirstBit == FALSE )
                FirstBit = TRUE;
            i = GetUpSectorData( &BackFdtSector );
            if( i == ERR_SUCCESS )
            {
                CH374vFdtOffset = CH374vSectorSize;
                goto P_NEXT1;
            }
        }
        else
        {
            // ȡƫƺݣֱƫ
            P_NEXT1:
            offset = CH374vFdtOffset;
            while( 1 )
            {
                if( offset != 0 )
                {
                    offset = offset - 32;
                    if( ( DISK_BASE_BUF[offset + 11] == ATTR_LONG_NAME )
                        && (  DISK_BASE_BUF[offset + 13] == sum ) )
                    {
                        if( (index + 26) > LONG_NAME_BUF_LEN )
                            return ERR_BUF_OVER;

                        for( i=0; i!=5; i++)            // ļ1-5ַ
                        {                               // ڴUNICODEС˷ʽ
                            #if UNICODE_ENDIAN == 1
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + i*2 + 2];
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + i*2 + 1];
                            #else
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + i*2 + 1];
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + i*2 + 2];
                            #endif
                        }

                        for( i =0; i!=6; i++)           // ļ6-11ַ
                        {
                            #if UNICODE_ENDIAN == 1
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + 14 + i*2 + 1];
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + + 14 + i*2 ];
                            #else
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + + 14 + i*2 ];
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + 14 + i*2 + 1];
                            #endif

                        }

                        for( i=0; i!=2; i++)            // ļ12-13ַ
                        {
                            #if UNICODE_ENDIAN == 1
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + 28 + i*2 + 1];
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + 28 + i*2 ];
                            #else
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + 28 + i*2 ];
                            LongNameBuf[index++] =
                                DISK_BASE_BUF[offset + 28 + i*2 + 1];
                            #endif
                        }

                        if( DISK_BASE_BUF[offset] & 0X40 )
                        {
                            if( ! (((LongNameBuf[index -1] ==0x00)
                                && (LongNameBuf[index -2] ==0x00))
                                || ((LongNameBuf[index -1] ==0xFF)
                                && (LongNameBuf[index -2 ] ==0xFF))))
                            {                           // պΪ26ֽڳļ
                                if(index + 52 >LONG_NAME_BUF_LEN )
                                    return ERR_BUF_OVER;
                                LongNameBuf[ index ] = 0x00;
                                LongNameBuf[ index + 1] = 0x00;
                            }
                            return ERR_SUCCESS;         // ɹɳļռ
                        }
                    }
                    else
                        return ERR_NO_NAME;             // ĳļ,򷵻
                }
                else
                {
                    if( FirstBit == FALSE )
                        FirstBit = TRUE;
                    else                                // ڶν
                    {
                        for( i=0; i!=MAX_PATH_LEN; i++ )// ԭ·
                            mCmdParam.Open.mPathName[i] = BackPathBuf[i];
                    }
                    i = GetUpSectorData( &BackFdtSector );
                    if( i == ERR_SUCCESS )
                    {
                        CH374vFdtOffset = CH374vSectorSize;
                        goto P_NEXT1;
                    }
                    else
                        return i;
                    // ƫ
                }
            }
        }
    }
    return i;                // ش
}

/*
ļʾ(UNICODEĴС UNICODE_ENDIANͬ)
LongName:
ļ 1.(unicode )ַĩβ0ʾ;2.ANSIļ.TXT
*/
UINT8 code LongName[] =
#if UNICODE_ENDIAN ==1
{
    0x5E, 0xFA, 0x7A, 0xCB, 0x95, 0x7F, 0x65, 0x87, 0x4E, 0xF6, 0x54, 0x0D, 0xFF, 0x0C, 0x8F, 0x93,
    0x51, 0x65, 0x4E, 0x24, 0x4E, 0x2A, 0x53, 0xC2, 0x65, 0x70, 0xFF, 0x1A, 0x00, 0x20, 0x00, 0x31,
    0x00, 0x2E, 0x91, 0xC7, 0x75, 0x28, 0x00, 0x28, 0x00, 0x75, 0x00, 0x6E, 0x00, 0x69, 0x00, 0x63,
    0x00, 0x6F, 0x00, 0x64, 0x00, 0x65, 0x00, 0x20, 0x59, 0x27, 0x7A, 0xEF, 0x00, 0x29, 0xFF, 0x0C,
    0x5B, 0x57, 0x7B, 0x26, 0x4E, 0x32, 0x67, 0x2B, 0x5C, 0x3E, 0x75, 0x28, 0x4E, 0x24, 0x4E, 0x2A,
    0x00, 0x30, 0x88, 0x68, 0x79, 0x3A, 0x7E, 0xD3, 0x67, 0x5F, 0x00, 0x3B, 0x00, 0x32, 0x00, 0x2E,
    0x00, 0x41, 0x00, 0x4E, 0x00, 0x53, 0x00, 0x49, 0x7F, 0x16, 0x78, 0x01, 0x77, 0xED, 0x65, 0x87,
    0x4E, 0xF6, 0x54, 0x0D, 0x00, 0x2E, 0x00, 0x54, 0x00, 0x58, 0x00, 0x54
};
#else
{
    0xFA, 0x5E, 0xCB, 0x7A, 0x7F, 0x95, 0x87, 0x65, 0xF6, 0x4E, 0x0D, 0x54, 0x0C, 0xFF, 0x93, 0x8F,
    0x65, 0x51, 0x24, 0x4E, 0x2A, 0x4E, 0xC2, 0x53, 0x70, 0x65, 0x1A, 0xFF, 0x20, 0x00, 0x31, 0x00,
    0x2E, 0x00, 0xC7, 0x91, 0x28, 0x75, 0x28, 0x00, 0x75, 0x00, 0x6E, 0x00, 0x69, 0x00, 0x63, 0x00,
    0x6F, 0x00, 0x64, 0x00, 0x65, 0x00, 0x20, 0x00, 0x27, 0x59, 0xEF, 0x7A, 0x29, 0x00, 0x0C, 0xFF,
    0x57, 0x5B, 0x26, 0x7B, 0x32, 0x4E, 0x2B, 0x67, 0x3E, 0x5C, 0x28, 0x75, 0x24, 0x4E, 0x2A, 0x4E,
    0x30, 0x00, 0x68, 0x88, 0x3A, 0x79, 0xD3, 0x7E, 0x5F, 0x67, 0x3B, 0x00, 0x32, 0x00, 0x2E, 0x00,
    0x41, 0x00, 0x4E, 0x00, 0x53, 0x00, 0x49, 0x00, 0x16, 0x7F, 0x01, 0x78, 0xED, 0x77, 0x87, 0x65,
    0xF6, 0x4E, 0x0D, 0x54, 0x2E, 0x00, 0x54, 0x00, 0x58, 0x00, 0x54, 0x00
};
#endif

main( ) {
	UINT8	i;
    UINT16  j;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH374רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );

#ifdef UNSUPPORT_USB_HUB
/* Ҫ֧USB-HUB,ôȴU̲ĳCH374,ͨCH374DiskConnectѯ,ͨCH374DiskReadyȴ,Ȼд */
		while ( CH374DiskStatus < DISK_CONNECT ) {  /* ѯCH374жϲж״̬,ȴU̲ */
			CH374DiskConnect( );
			CH374DelaymS( 50 );  /* ûҪƵѯ */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
		for ( i = 0; i < 100; i ++ ) {  /* ȴʱ,100*50mS */
			CH374DelaymS( 50 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
			if ( CH374DiskStatus < DISK_CONNECT ) break;  /* ⵽Ͽ,¼Ⲣʱ */
			if ( CH374DiskStatus >= DISK_MOUNTED && i > 5 ) break;  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
		}
		if ( CH374DiskStatus < DISK_CONNECT ) {  /* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;  /* µȴ */
		}
		if ( CH374DiskStatus < DISK_MOUNTED ) {  /* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
#else
/* Ҫ֧USB-HUB,ôοĵȴ */
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 50 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) {  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
				CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,ȴ5*50mS,ҪDiskReady */
				for ( i = 0; i < 100; i ++ ) {  /* ȴʱ,100*50mS */
					CH374DelaymS( 50 );
					printf( "Ready ?\n" );
					if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
					if ( CH374DiskStatus < DISK_CONNECT ) {  /* ⵽Ͽ,¼Ⲣʱ */
						printf( "Device gone\n" );
						break;  /* µȴ */
					}
					if ( CH374DiskStatus >= DISK_MOUNTED && i > 5 ) break;  /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
					if ( CH374DiskStatus == DISK_CONNECT ) {  /* 豸 */
						if ( CH374vHubPortCount ) {  /* һUSB-HUB,ûU */
							printf( "No Udisk in USB_HUB\n" );
							break;
						}
						else {  /* δ֪USB豸,пU̷Ӧ̫,Ҫ */
						}
					}
				}
				if ( CH374DiskStatus >= DISK_MOUNTED ) {  /* U */
					break;  /* ʼU */
				}
				if ( CH374DiskStatus == DISK_CONNECT ) {  /* γԻǲ,ƲU */
					if ( CH374vHubPortCount ) {  /* һUSB-HUB,ûU */
/* whileеȴHUB˿U */
					}
					else {  /* δ֪USB豸,USB̡ӡ,Ѿ˺ܶλ */
						printf( "Unknown device\n" );
						goto UnknownUsbDevice;
					}
				}
			}
		}
		LED_OUT_ACT( );  /* LED */
#endif

#if DISK_BASE_BUF_LEN
		if ( DISK_BASE_BUF_LEN < CH374vSectorSize ) {  /* ݻǷ㹻,CH374vSectorSizeU̵ʵС */
			printf( "Too large sector size\n" );
			goto UnknownUsbDevice;
		}
#endif
	
/*==================== ʾȡļ ============================*/
        // Ƴļ(UNICODE )LongNameBuf
        memcpy( LongNameBuf, LongName, sizeof(LongName) );
        // ĩβ0ʾ
        LongNameBuf[sizeof(LongName)] = 0x00;
        LongNameBuf[sizeof(LongName) + 1] = 0x00;
        // óļANSIļ(8+3ʽ)
        strcpy( mCmdParam.Create.mPathName, "\\C51\\AA\\ļ.TXT" );
        i = CH374CreateLongName( );
        if( i == ERR_SUCCESS )
            printf( "Created Long Name OK!!\n" );
        else
            printf( "Error Code: %02X\n", (UINT16)i );

        printf( "Get long Name#\n" );
        strcpy( mCmdParam.Open.mPathName, "\\C51\\AA\\ļ.TXT" );
        // Ҫļ·
        i = CH374GetLongName( );
        if( i == ERR_SUCCESS )
        {
            // ļռ,UNICODE뷽ʽ(UNICODE_ENDIAN)
            // LongNameBuf,ļ0.
            // ʾ
            printf( "LongNameBuf: " );
            for( j=0; j!=LONG_NAME_BUF_LEN; j++ )
                printf( "%02X ", (UINT16)LongNameBuf[j] );
            printf( "\n" );
        }
        else
            printf( "Error Code: %02X\n", (UINT16)i );
/*==============================================================================*/

UnknownUsbDevice:
		LED_RUN_INACT( );
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
