/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, KC7.0@MCS51             **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MCS-51ƬCԵUļдʾ, 89C52߸ռĵƬ,ҲATMEL/PHILIPS/SSTȾ1KBڲRAMĵƬ */
/* ʾCH374Uõ3˿ڸRoot-HUB,
   һ˿ڲUοEXAM7ֽģʽдļ,Ŀ¼ļΪMY_ADC.TXT,RAM1Kֽ,Ҳɸĳд,
   豸U,ʼöٸUSB豸,֧ȫUSB豸ߵUSB豸,USB̵,3HUB˿ֻܲһU
*/
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"DPTR", ٶȽ, MCS51Ƭ */


/* C51   CH374HFT.C */
/* LX51  CH374HFT.OBJ , CH374HF6.LIB, C51DPTR1.LIB */
/* OHX51 CH374HFT */

#include <reg52.h>
#include <stdio.h>
#include <string.h>

#define	MAX_BYTE_IO				35		/* ֽΪλζдļʱ󳤶,Ĭֵ29,ֵռڴ,ֵС򳬹óȱֶζд */

/* ¶ϸ˵뿴CH374HF6.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

#define CH374_IDX_PORT_ADDR		0xBDF1	/* CH374˿ڵI/Oַ */
#define CH374_DAT_PORT_ADDR		0xBCF0	/* CH374ݶ˿ڵI/Oַ */
//#define CH374_IDX_PORT_ADDR		0xEFFF	/* CH374˿ڵI/Oַ */
//#define CH374_DAT_PORT_ADDR		0xE000	/* CH374ݶ˿ڵI/Oַ */
/* ֻʹõƬõ1KBⲿRAM: 0000H-01FFH Ϊ̶д, ֽΪλдļҪļݶдFILE_DATA_BUF */
#define	DISK_BASE_BUF_ADDR		0x0000	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */

#define CH374_INT_WIRE			INT0	/* P3.2, INT0, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#include "..\CH374HF6.H"				/* Ҫ֧FAT32,ôѡCH374HF6.H */

/* USBṹس */

typedef struct _USB_SETUP_REQ {
	UINT8	bType;
	UINT8	bReq;
	UINT8	wValueL;
	UINT8	wValueH;
	UINT8	wIndexL;
	UINT8	wIndexH;
	UINT8	wLengthL;
	UINT8	wLengthH;
} USB_SETUP_REQ, *PUSB_SETUP_REQ;

typedef struct _USB_DEVICE_DESCRIPTOR {
    UINT8 bLength;
    UINT8 bDescriptorType;
    UINT8 bcdUSBL;
    UINT8 bcdUSBH;
    UINT8 bDeviceClass;
    UINT8 bDeviceSubClass;
    UINT8 bDeviceProtocol;
    UINT8 bMaxPacketSize0;
    UINT8 idVendorL;
    UINT8 idVendorH;
    UINT8 idProductL;
    UINT8 idProductH;
    UINT8 bcdDeviceL;
    UINT8 bcdDeviceH;
    UINT8 iManufacturer;
    UINT8 iProduct;
    UINT8 iSerialNumber;
    UINT8 bNumConfigurations;
} USB_DEV_DESCR, *PUSB_DEV_DESCR;

typedef struct _USB_CONFIG_DESCRIPTOR {
    UINT8 bLength;
    UINT8 bDescriptorType;
    UINT8 wTotalLengthL;
    UINT8 wTotalLengthH;
    UINT8 bNumInterfaces;
    UINT8 bConfigurationValue;
    UINT8 iConfiguration;
    UINT8 bmAttributes;
    UINT8 MaxPower;
} USB_CFG_DESCR, *PUSB_CFG_DESCR;

typedef struct _USB_INTERF_DESCRIPTOR {
    UINT8 bLength;
    UINT8 bDescriptorType;
    UINT8 bInterfaceNumber;
    UINT8 bAlternateSetting;
    UINT8 bNumEndpoints;
    UINT8 bInterfaceClass;
    UINT8 bInterfaceSubClass;
    UINT8 bInterfaceProtocol;
    UINT8 iInterface;
} USB_ITF_DESCR, *PUSB_ITF_DESCR;

typedef struct _USB_ENDPOINT_DESCRIPTOR {
    UINT8 bLength;
    UINT8 bDescriptorType;
    UINT8 bEndpointAddress;
    UINT8 bmAttributes;
    UINT8 wMaxPacketSize;
    UINT8 wMaxPacketSize1;
    UINT8 bInterval;
} USB_ENDP_DESCR, *PUSB_ENDP_DESCR;

typedef struct _USB_CONFIG_DESCRIPTOR_LONG {
	USB_CFG_DESCR	cfg_descr;
	USB_ITF_DESCR	itf_descr;
	USB_ENDP_DESCR	endp_descr[4];
} USB_CFG_DESCR_LONG, *PUSB_CFG_DESCR_LONG;

#define		TRUE	1
#define		FALSE	0

/* P1.4һLEDڼʾĽ,͵ƽLED,U̲ */
sbit P1_4  = P1^4;
#define LED_OUT_INIT( )		{ P1_4 = 1; }	/* P1.4 ߵƽ */
#define LED_OUT_ACT( )		{ P1_4 = 0; }	/* P1.4 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1_4 = 1; }	/* P1.4 ͵ƽLEDʾ */
sbit P1_5  = P1^5;
/* P1.5һLEDڼʾĽ,͵ƽLED,U̲ʱ */
#define LED_RUN_ACT( )		{ P1_5 = 0; }	/* P1.5 ͵ƽLEDʾ */
#define LED_RUN_INACT( )	{ P1_5 = 1; }	/* P1.5 ͵ƽLEDʾ */
sbit P1_6  = P1^6;
/* P1.6һLEDڼʾĽ,͵ƽLED,Uдʱ */
#define LED_WR_ACT( )		{ P1_6 = 0; }	/* P1.6 ͵ƽLEDʾ */
#define LED_WR_INACT( )		{ P1_6 = 1; }	/* P1.6 ͵ƽLEDʾ */

/* ´öٷU豸 */

// ȡ豸
const	UINT8	code	SetupGetDevDescr[] = { 0x80, 0x06, 0x00, 0x01, 0x00, 0x00, 0x12, 0x00 };
// ȡ
const	UINT8	code	SetupGetCfgDescr[] = { 0x80, 0x06, 0x00, 0x02, 0x00, 0x00, 0x04, 0x00 };
// USBַ
const	UINT8	code	SetupSetUsbAddr[] = { 0x00, 0x05, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00 };
// USB
const	UINT8	code	SetupSetUsbConfig[] = { 0x00, 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

UINT8	UsbDevEndpSize = DEFAULT_ENDP0_SIZE;	/* USB豸Ķ˵0ߴ */

//USB豸ϢCH374U֧3豸
#define		ROOT_DEV_DISCONNECT		0
#define		ROOT_DEV_CONNECTED		1
#define		ROOT_DEV_FAILED			2
#define		ROOT_DEV_SUCCESS		3
struct _RootHubDev{
	UINT8	DeviceStatus;			// 豸״̬,0-豸,1-豸δʼ,2-豸ʼöʧ,3-豸ҳʼöٳɹ
	UINT8	DeviceAddress;			// 豸USBַ
	UINT8	DeviceSpeed;			// 0Ϊ,0Ϊȫ
	UINT8	DeviceType;				// 豸
//	union {
//		struct MOUSE {
//			UINT8	MouseInterruptEndp;		// ж϶˵
//			UINT8	MouseIntEndpTog;		// ж϶˵ͬ־
//			UINT8	MouseIntEndpSize;		// ж϶˵ĳ
//		}
//		struct PRINT {
//		}
//	}
//.....    struct  _Endp_Attr   Endp_Attr[4];	//˵,֧4˵
} xdata RootHubDev[3];

UINT8	xdata	CtrlBuf[8];
UINT8	xdata	TempBuf[64];

void	HostEnableRootHub( void );  // õRoot-HUB

UINT8	HostCtrlTransfer374( PUINT8 ReqBuf, PUINT8 DatBuf, PUINT8 RetLen );  // ִпƴ,ReqBufָ8ֽ,DatBufΪշ
// ҪպͷݣôDatBufָЧڴźݣʵʳɹշܳȱReqLenָֽڱ

void	SetHostUsbAddr( UINT8 addr );  // USBǰUSB豸ַ

UINT8	GetDeviceDescr( PUINT8 buf );  // ȡ豸

UINT8	GetConfigDescr( PUINT8 buf );  // ȡ

UINT8	SetUsbAddress( UINT8 addr );  // USB豸ַ

UINT8	SetUsbConfig( UINT8 cfg );  // USB豸

void	DisableRootHubPort( UINT8 index );  // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬

void	ResetRootHubPort( UINT8 index );  // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ

UINT8	EnableRootHubPort( UINT8 index );  // ʹROOT-HUB˿,ӦBIT_HUB?_EN1˿,FALSEʧ(豸Ͽ)

void	SetUsbSpeed( UINT8 FullSpeed );  // õǰUSBٶ

void	SelectHubPort( UINT8 index );  // ѡָROOT-HUB˿

UINT8	InitDevUsbDisk( void );  // CH374LIBʼU

UINT8	InitDevice( UINT8 index );  // ʼ/öָROOT-HUB˿ڵUSB豸

UINT8	SearchHubPort( UINT8 type );  // ָ͵豸ڵĶ˿ں,˿ںΪ0xFFδ

UINT8	WriteToDiskFile( void );  // Uļ׷д,ӳEXAM7


void	HostEnableRootHub( void )  // õRoot-HUB
{
//	CH374_WRITE_REGISTER( REG_USB_SETUP, M_SET_USB_BUS_FREE( CH374_READ_REGISTER( REG_USB_SETUP ) ) );  // USB߿
	CH374_WRITE_REGISTER( REG_USB_SETUP, BIT_SETP_HOST_MODE | BIT_SETP_AUTO_SOF );  // USBʽ,SOF
	CH374_WRITE_REGISTER( REG_HUB_SETUP, 0x00 );  // BIT_HUB_DISABLE,õROOT-HUB
	CH374_WRITE_REGISTER( REG_HUB_CTRL, 0x00 );  // ROOT-HUBϢ
}

UINT8	HostCtrlTransfer374( PUINT8 ReqBuf, PUINT8 DatBuf, PUINT8 RetLen )  // ִпƴ,ReqBufָ8ֽ,DatBufΪշ
// ҪպͷݣôDatBufָЧڴźݣʵʳɹշܳȱReqLenָֽڱ
{
	UINT8	s;
	for ( s = 0; s != 8; s ++ ) CH374_WRITE_REGISTER( RAM_HOST_TRAN + s, *( ReqBuf + s ) );  // Ԥд
	CH374DirtyBuffer( );  // CH374CtrlTransferʹpDISK_BASE_BUF,ڴҲɲpDISK_BASE_BUF,οHOST.Cдƴӳ
	s = CH374CtrlTransfer( );  // ƴ
	if ( s == ERR_SUCCESS ) {
		*RetLen = *(ReqBuf+6);  // 󳤶
		memcpy( DatBuf, pDISK_BASE_BUF, *RetLen );  // 
		return( USB_INT_SUCCESS );
	}
	return( s );
}

void	SetHostUsbAddr( UINT8 addr )  // USBǰUSB豸ַ
{
	CH374_WRITE_REGISTER( REG_USB_ADDR, addr );
}

UINT8	GetDeviceDescr( PUINT8 buf )  // ȡ豸
{
	UINT8	s, len;
	UsbDevEndpSize = DEFAULT_ENDP0_SIZE;
	s = HostCtrlTransfer374( SetupGetDevDescr, buf, &len );  // ִпƴ
	if ( s == USB_INT_SUCCESS ) {
		UsbDevEndpSize = ( (PUSB_DEV_DESCR)buf ) -> bMaxPacketSize0;  // ˵0,Ǽ򻯴,ӦȻȡǰ8ֽںUsbDevEndpSizeټ
		if ( len < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL ) s = USB_INT_BUF_OVER;  // ȴ
	}
	return( s );
}

UINT8	GetConfigDescr( PUINT8 buf )  // ȡ
{
	UINT8	s, len;
	s = HostCtrlTransfer374( SetupGetCfgDescr, buf, &len );  // ִпƴ
	if ( s == USB_INT_SUCCESS ) {
		if ( len < ( (PUSB_SETUP_REQ)SetupGetCfgDescr ) -> wLengthL ) s = USB_INT_BUF_OVER;  // سȴ
		else {
			len = ( (PUSB_CFG_DESCR)buf ) -> wTotalLengthL;
			memcpy ( CtrlBuf, SetupGetCfgDescr, sizeof( SetupGetCfgDescr ) );
			( (PUSB_SETUP_REQ)CtrlBuf ) -> wLengthL = len;  // ܳ
			s = HostCtrlTransfer374( CtrlBuf, buf, &len );  // ִпƴ
			if ( s == USB_INT_SUCCESS ) {
				if ( len < ( (PUSB_CFG_DESCR)buf ) -> wTotalLengthL ) s = USB_INT_BUF_OVER;  // ȴ
			}
		}
	}
	return( s );
}

UINT8	SetUsbAddress( UINT8 addr )  // USB豸ַ
{
	UINT8	s;
	memcpy ( CtrlBuf, SetupSetUsbAddr, sizeof( SetupSetUsbAddr ) );
	( (PUSB_SETUP_REQ)CtrlBuf ) -> wValueL = addr;  // USB豸ַ
	s = HostCtrlTransfer374( CtrlBuf, NULL, NULL );  // ִпƴ
	if ( s == USB_INT_SUCCESS ) {
		SetHostUsbAddr( addr );  // USBǰUSB豸ַ
	}
	CH374DelaymS( 10 );  // ȴUSB豸ɲ
	return( s );
}

UINT8	SetUsbConfig( UINT8 cfg )  // USB豸
{
	memcpy ( CtrlBuf, SetupSetUsbConfig, sizeof( SetupSetUsbConfig ) );
	( (PUSB_SETUP_REQ)CtrlBuf ) -> wValueL = cfg;  // USB豸
	return( HostCtrlTransfer374( CtrlBuf, NULL, NULL ) );  // ִпƴ
}

void	DisableRootHubPort( UINT8 index )  // رָROOT-HUB˿,ʵӲѾԶر,˴ֻһЩṹ״̬
{
	RootHubDev[ index ].DeviceStatus = ROOT_DEV_DISCONNECT;
	RootHubDev[ index ].DeviceAddress = 0x00;
	if ( index == 1 ) CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL)&0xF0 );  // йHUB1Ŀ,ʵϲҪ
	else if ( index == 2 ) CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL)&0x0F );  // йHUB2Ŀ,ʵϲҪ
	else CH374_WRITE_REGISTER( REG_HUB_SETUP, CH374_READ_REGISTER(REG_HUB_SETUP)&0xF0 );  // йHUB0Ŀ,ʵϲҪ
//	printf( "HUB %01x close\n",(UINT16)index );
}

void	ResetRootHubPort( UINT8 index )  // ⵽豸,λӦ˿ڵ,Ϊö豸׼,ΪĬΪȫ
{
	UsbDevEndpSize = DEFAULT_ENDP0_SIZE;  /* USB豸Ķ˵0ߴ */
	SetHostUsbAddr( 0x00 );
	CH374_WRITE_REGISTER( REG_USB_H_CTRL, 0x00 );
	if ( index == 1 ) {
		CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL) & ~ BIT_HUB1_POLAR | BIT_HUB1_RESET );  // ĬΪȫ,ʼλ
		CH374DelaymS( 15 );																 // λʱ10mS20mS
		CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL) & ~ BIT_HUB1_RESET );  // λ
	}
	else if ( index == 2 ) {
		CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL) & ~ BIT_HUB2_POLAR | BIT_HUB2_RESET );  // ĬΪȫ,ʼλ
		CH374DelaymS( 15 );																 // λʱ10mS20mS
		CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL) & ~ BIT_HUB2_RESET );  // λ
	}
	else {
		CH374_WRITE_REGISTER( REG_HUB_SETUP, CH374_READ_REGISTER(REG_HUB_SETUP) & ~ BIT_HUB0_POLAR | BIT_HUB0_RESET );  // ĬΪȫ,ʼλ
		CH374DelaymS( 15 );																 // λʱ10mS20mS
		CH374_WRITE_REGISTER( REG_HUB_SETUP, CH374_READ_REGISTER(REG_HUB_SETUP) & ~ BIT_HUB0_RESET );  // λ
	}
	CH374_WRITE_REGISTER( REG_INTER_FLAG, BIT_IF_USB_PAUSE | BIT_IF_DEV_DETECT | BIT_IF_USB_SUSPEND );  // жϱ־
}

UINT8	EnableRootHubPort( UINT8 index )  // ʹROOT-HUB˿,ӦBIT_HUB?_EN1˿,FALSEʧ(豸Ͽ)
{
	if ( RootHubDev[ index ].DeviceStatus < ROOT_DEV_CONNECTED ) RootHubDev[ index ].DeviceStatus = ROOT_DEV_CONNECTED;
	if ( index == 1 ) {
		if ( CH374_READ_REGISTER(REG_HUB_CTRL)&BIT_HUB1_ATTACH ) {  // 豸
			if ( !(CH374_READ_REGISTER(REG_HUB_CTRL)&BIT_HUB1_EN) ) {  // δʹ
				if ( !(CH374_READ_REGISTER(REG_HUB_SETUP) & BIT_HUB1_DX_IN) ) CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL) ^ BIT_HUB1_POLAR );  // ٶȲƥü
				RootHubDev[1].DeviceSpeed= !( CH374_READ_REGISTER(REG_HUB_CTRL) & BIT_HUB1_POLAR );
			}
			CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL)|BIT_HUB1_EN );	//ʹHUB˿
			return( TRUE );
		}
	}
	else if ( index == 2 ) {
		if ( CH374_READ_REGISTER(REG_HUB_CTRL)&BIT_HUB2_ATTACH ) {  // 豸
			if ( !(CH374_READ_REGISTER(REG_HUB_CTRL)&BIT_HUB2_EN) ) {  // δʹ
				if ( !(CH374_READ_REGISTER(REG_HUB_SETUP) & BIT_HUB2_DX_IN) ) CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL) ^ BIT_HUB2_POLAR );  // ٶȲƥü
				RootHubDev[2].DeviceSpeed= !( CH374_READ_REGISTER(REG_HUB_CTRL) & BIT_HUB2_POLAR );
			}
			CH374_WRITE_REGISTER( REG_HUB_CTRL, CH374_READ_REGISTER(REG_HUB_CTRL)|BIT_HUB2_EN );	//ʹHUB˿
			return( TRUE );
		}
	}
	else {
		if ( CH374_READ_REGISTER(REG_HUB_SETUP)&BIT_HUB0_ATTACH ) {  // 豸
			if ( !(CH374_READ_REGISTER(REG_HUB_SETUP)&BIT_HUB0_EN) ) {  // δʹ
				if ( !(CH374_READ_REGISTER(REG_INTER_FLAG) & BIT_HUB0_DX_IN) ) CH374_WRITE_REGISTER( REG_HUB_SETUP, CH374_READ_REGISTER(REG_HUB_SETUP) ^ BIT_HUB0_POLAR );  // ٶȲƥü
				RootHubDev[0].DeviceSpeed= !( CH374_READ_REGISTER(REG_HUB_SETUP) & BIT_HUB0_POLAR );
			}
			CH374_WRITE_REGISTER( REG_HUB_SETUP, CH374_READ_REGISTER(REG_HUB_SETUP)|BIT_HUB0_EN );  //ʹHUB˿
			return( TRUE );
		}
	}
	return( FALSE );
}

void	SetUsbSpeed( UINT8 FullSpeed )  // õǰUSBٶ
{
	if ( FullSpeed ) {  // ȫ
		CH374_WRITE_REGISTER( REG_USB_SETUP, CH374_READ_REGISTER( REG_USB_SETUP ) & BIT_SETP_RAM_MODE | BIT_SETP_HOST_MODE | BIT_SETP_AUTO_SOF );  // ȫ
		CH374_WRITE_REGISTER( REG_HUB_SETUP, CH374_READ_REGISTER( REG_HUB_SETUP ) & ~ BIT_HUB_PRE_PID );  // ֹPRE PID
	}
	else CH374_WRITE_REGISTER( REG_USB_SETUP, CH374_READ_REGISTER( REG_USB_SETUP ) & BIT_SETP_RAM_MODE | BIT_SETP_HOST_MODE | BIT_SETP_AUTO_SOF | BIT_SETP_LOW_SPEED );  // 
}

void	SelectHubPort( UINT8 index )  // ѡָROOT-HUB˿
{
	SetHostUsbAddr( RootHubDev[index].DeviceAddress );  // USBǰUSB豸ַ
//	if ( RootHubDev[index].DeviceSpeed == FALSE && 豸ⲿHUBĳ˿ )  // ͨⲿHUBUSB豸ͨѶҪǰID
//		CH374_WRITE_REGISTER( REG_HUB_SETUP, CH374_READ_REGISTER( REG_HUB_SETUP ) | BIT_HUB_PRE_PID );  // PRE PID
	SetUsbSpeed( RootHubDev[index].DeviceSpeed );  // õǰUSBٶ
	CH374vEmbHubIndex = index + 1;  // UڵĶ˿ں,֪ͨUӳ
}

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 100 );
		LED_OUT_INACT( );
		CH374DelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	SCON = 0x50;
	PCON = 0x80;
//	TL2 = RCAP2L = 0 - 10; /* 18.432MHz, 57600bps */
	TL2 = RCAP2L = 0 - 13; /* 24MHz, 57600bps */
	TH2 = RCAP2H = 0xFF;
	T2CON = 0x34;  /* ʱ2ڴڵĲʷ */
	TI = 1;
}

UINT8	InitDevUsbDisk( void )  // CH374LIBʼU
{
/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
	UINT8	i;
	for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
		printf( "DiskReady ?\n" );
		if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		if ( CH374DiskStatus >= DISK_MOUNTED && i > 1 ) break;  /* еUǷδ׼,Ա */
		CH374DelaymS( 100 );
	}
	if ( CH374DiskStatus >= DISK_MOUNTED ) return( ERR_SUCCESS );  // ɹ,Ѿʼװϵͳ
	return( ERR_DISK_DISCON );  // ֻ֧߲U
}

UINT8	InitDevice( UINT8 index )  // ʼ/öָROOT-HUB˿ڵUSB豸
// : HUB˿ں0/1/2
// : 0-ʧ, 0x31-ɹöٵUSB, 0x32-ɹöٵ, 0x70-ɹöٵӡ, 0x80-ɹöٵU, 0xFF-ɹöδ֪豸, ֵδ
#define	DEV_ERROR		0x00
#define	DEV_KEYBOARD	0x31
#define	DEV_MOUSE		0x32
#define	DEV_PRINT		0x70
#define	DEV_DISK		0x80
#define	DEV_HUB			0x90
#define	DEV_UNKNOWN		0xFF
{
	UINT8	i, s, cfg, dv_cls, if_cls;
	printf( "Start reset HUB%01d port\n", (UINT16)index );
	ResetRootHubPort( index );  // ⵽豸,λӦ˿ڵUSB
	for ( i = 0, s = 0; i < 100; i ++ ) {  // ȴUSB豸λ
		if ( EnableRootHubPort( index ) ) {  // ʹROOT-HUB˿
			i = 0;
			s ++;  // ʱȴUSB豸Ӻȶ
			if ( s > 100 ) break;  // Ѿȶ
		}
		CH374DelaymS( 1 );
	}
	if ( i ) {  // λ豸û
		DisableRootHubPort( index );
		printf( "Disable HUB%01d port because of disconnect\n", (UINT16)index );
		return( DEV_ERROR );
	}
	SetUsbSpeed( RootHubDev[index].DeviceSpeed );  // õǰUSBٶ
	printf( "GetDeviceDescr @HUB%1d: ", (UINT16)index );
	s = GetDeviceDescr( TempBuf );  // ȡ豸
	if ( s == USB_INT_SUCCESS ) {
		for ( i = 0; i < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; i ++ ) printf( "0x%02X ", (UINT16)( TempBuf[i] ) );
		printf( "\n" ); // ʾ
		dv_cls = ( (PUSB_DEV_DESCR)TempBuf ) -> bDeviceClass;  // 豸
		s = SetUsbAddress( index + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL );  // USB豸ַ,indexԱ֤HUB˿ڷ䲻ͬĵַ
		if ( s == USB_INT_SUCCESS ) {
			RootHubDev[index].DeviceAddress = index + ( (PUSB_SETUP_REQ)SetupSetUsbAddr ) -> wValueL;  // USBַ
			printf("GetConfigDescr:\n" );
			s = GetConfigDescr( TempBuf );  // ȡ
			if ( s == USB_INT_SUCCESS ) {
				cfg = ((PUSB_CFG_DESCR)TempBuf ) -> bConfigurationValue;
				for ( i = 0; i < ( (PUSB_CFG_DESCR)TempBuf ) -> wTotalLengthL; i ++ ) printf( "0x%02X ", (UINT16)( TempBuf[i] ) );
				printf("\n");
/* ȡ˵/˵ַ/˵Сȣ±endp_addrendp_size */
				if_cls = ( (PUSB_CFG_DESCR_LONG)TempBuf ) -> itf_descr.bInterfaceClass;  // ӿ
				if ( dv_cls == 0x00 && if_cls == 0x08 ) {  // USB洢豸,ȷU
					if ( CH374DiskStatus >= DISK_MOUNTED ) printf( "Too many USB-Disk, discard previous\n" );
					CH374DiskStatus = DISK_DISCONNECT;  // ״̬Ա³ʼ(ǽһ˿ڵU̵״̬)
					s = InitDevUsbDisk( );  // CH374LIBʼU
					if ( s == ERR_SUCCESS ) {  // ɹ,Ѿʼװϵͳ
						RootHubDev[index].DeviceStatus =ROOT_DEV_SUCCESS;
//						SetUsbSpeed( TRUE );  // ĬΪȫ
						printf( "USB-Disk Ready\n" );
						return( DEV_DISK );  /* U̳ʼɹ */
					}
				}
				else if ( dv_cls == 0x00 && if_cls == 0x07 && ( (PUSB_CFG_DESCR_LONG)TempBuf ) -> itf_descr.bInterfaceSubClass == 0x01 ) {  // Ǵӡ豸
					s = SetUsbConfig( cfg );  // USB豸
					if ( s == USB_INT_SUCCESS ) {
//						豣˵ϢԱUSB
						RootHubDev[index].DeviceStatus =ROOT_DEV_SUCCESS;
						SetUsbSpeed( TRUE );  // ĬΪȫ
						printf( "USB-Print Ready\n" );
						return( DEV_PRINT );  /* ӡʼɹ */
					}
				}
				else if ( dv_cls == 0x00 && if_cls == 0x03 && ( (PUSB_CFG_DESCR_LONG)TempBuf ) -> itf_descr.bInterfaceSubClass <= 0x01 ) {  // HID豸,/
					s = SetUsbConfig( cfg );  // USB豸
					if ( s == USB_INT_SUCCESS ) {
//						豣˵ϢԱUSB
						RootHubDev[index].DeviceStatus =ROOT_DEV_SUCCESS;
						SetUsbSpeed( TRUE );  // ĬΪȫ
						s = ( (PUSB_CFG_DESCR_LONG)TempBuf ) -> itf_descr.bInterfaceProtocol;
						if ( s == 1 ) {
//							һʼ,豸ָʾLED
							printf( "USB-Keyboard Ready\n" );
							return( DEV_KEYBOARD );  /* ̳ʼɹ */
						}
						else if ( s == 2 ) {
//							ΪԺѯ״̬,Ӧ÷,ȡж϶˿ڵĵַ,ȵϢ
							printf( "USB-Mouse Ready\n" );
							return( DEV_MOUSE );  /* ʼɹ */
						}
					}
				}
				else if ( dv_cls == 0x09 ) {  // HUB豸,
// ʵ,CH374LIB֧HUBU,˴HUBҲǵHUBU,,ԵCH374DiskReadyһ,U򵱳HUB
					if ( CH374DiskStatus <= DISK_CONNECT ) {  // ĿǰûU,һ
						s = InitDevUsbDisk( );  // CH374LIBʼU
						if ( s == ERR_SUCCESS ) {  // ɹ,Ѿʼװϵͳ
							RootHubDev[index].DeviceAddress =CH374_READ_REGISTER( REG_USB_ADDR );  // HUB˿ڵU̵ĵַ(HUBַ)
							RootHubDev[index].DeviceStatus =ROOT_DEV_SUCCESS;
							SetUsbSpeed( TRUE );  // ĬΪȫ
							printf( "USB-Disk (embed with HUB) Ready\n" );
							return( DEV_DISK );  /* U̳ʼɹ */
						}
						CH374DiskStatus = DISK_DISCONNECT;  // ûU
						s = SetUsbAddress( RootHubDev[index].DeviceAddress );  // USB豸ַ
						if ( s == USB_INT_SUCCESS ) s = GetConfigDescr( TempBuf );  // »ȡ
						if ( s != USB_INT_SUCCESS ) printf( "Hub re-address or re-config error %02x\n", (UINT16)s );
					}
					s = SetUsbConfig( cfg );  // USB豸
					if ( s == USB_INT_SUCCESS ) {  // οEVT\EMB_HUB\ROOTHUB.C
//						豣˵ϢԱUSB
//						HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
						RootHubDev[index].DeviceStatus =ROOT_DEV_SUCCESS;
						SetUsbSpeed( TRUE );  // ĬΪȫ
						printf( "USB-Hub Ready\n" );  // οEVT\EMB_HUB\ROOTHUB.CⲿHUBö
						return( DEV_HUB );  /* HUBʼɹ */
					}
				}
				else {   // Խһ
					s = SetUsbConfig( cfg );  // USB豸
					if ( s == USB_INT_SUCCESS ) {
//						豣˵ϢԱUSB
						RootHubDev[index].DeviceStatus =ROOT_DEV_SUCCESS;
						SetUsbSpeed( TRUE );  // ĬΪȫ
						return( DEV_UNKNOWN );  /* δ֪豸ʼɹ */
					}
				}
			}
		}
	}
	printf( "InitDevice Error = %02X\n", (UINT16)s );
	RootHubDev[index].DeviceStatus =ROOT_DEV_FAILED;
	SetUsbSpeed( TRUE );  // ĬΪȫ
	return( DEV_ERROR );
}

UINT8	SearchHubPort( UINT8 type )  // ָ͵豸ڵĶ˿ں,˿ںΪ0xFFδ
{ // ȻҲԸUSBĳVIDƷPID(Ҫ¼豸VIDPID),Լָ
	UINT8	i;
	for ( i = 0; i < 3; i ++ ) {  // ʱԱ豸;γĳЩϢδʱµ
		if ( RootHubDev[i].DeviceType == type && RootHubDev[i].DeviceStatus >= ROOT_DEV_SUCCESS ) return( i );  // ƥöٳɹ
	}
	return( 0xFF );
}

UINT8	WriteToDiskFile( void )  // Uļ׷д,ӳEXAM7
{
	UINT8	i, month, hour;
	UINT16	date, adc, len;
	LED_RUN_ACT( );  /* ʼU */
// ǰѾжϹU̾
//	i = CH374DiskConnect( );  /* USB豸ǷӲ´״̬,سɹ˵ */
//	if ( i != ERR_SUCCESS ) return( i );  /* U̶Ͽ */
//	i = CH374DiskReady( );  /* ѯǷ׼ */
//	if ( i == ERR_DISK_DISCON ) return( i );
//	if ( i != ERR_SUCCESS ) return( i );  /* Uδ,еUԶʧܶʵѾ,ִֻжжϽ */

/* MY_ADC.TXTļѾݵβ,½ļ */
	printf( "Open\n" );
	strcpy( mCmdParam.Open.mPathName, "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼ */
	i = CH374FileOpen( );  /* ļ */
	if ( i == ERR_SUCCESS ) {  /* ļڲѾ,ƶļָ뵽βԱ */
		printf( "File size = %ld\n", CH374vFileSize );  /* ڳɹļ,ȫֱCH374vFileSizeļǰ */
		printf( "Locate tail\n" );
		mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  /* Ƶļβ */
		i = CH374ByteLocate( );
		if ( i != ERR_SUCCESS ) return( i );
	}
	else if ( i == ERR_MISS_FILE ) {  /* ûҵļ,½ļ */
		LED_WR_ACT( );  /* д */
		printf( "Create\n" );
/*		strcpy( mCmdParam.Create.mPathName, "/MY_ADC.TXT" );*/  /* ļ,ļڸĿ¼,ղѾṩCH374FileOpen */
		i = CH374FileCreate( );  /* ½ļ,ļѾɾ½ */
		if ( i != ERR_SUCCESS ) return( i );
	}
	else if ( i != ERR_SUCCESS ) return( i );  /* ļʱ */
	LED_WR_ACT( );  /* д */
	printf( "Write begin\n" );
	i = sprintf( mCmdParam.ByteWrite.mByteBuffer, "ǰļ= %ld ֽ\xd\xa", CH374vFileSize );
	mCmdParam.ByteWrite.mByteCount = i;  /* ָдֽ,ζдĳȲܳMAX_BYTE_IO */
	i = CH374ByteWrite( );  /* ֽΪλļд,ζдĳȲܳMAX_BYTE_IO */
	if ( i != ERR_SUCCESS ) return( i );
/* Ĭ,ֽmCmdParam.ByteWrite.mByteCountΪ0ôCH374ByteWriteֻдݶ޸ļ,
   ʱ䲻дӦøļ,ֹͻȻϵǰдļȲ,
   Ҫдݺ޸/ļ,ôֽmCmdParam.ByteWrite.mByteCountΪ0CH374ByteWriteǿиļ,
   ȷͻȻϵߺܿݲд򲻱ظļ,ٶȲU(Uڲڴ,Ƶд) */
	printf( "Write ADC data\n" );
	for ( hour = 8; hour != 20; hour ++  ) {  /* ѭʽ12 */
		TR0=1;  /* öʱ0ļֵADC */
		month = 5;  /* ٶ5 */
		date = TL1 & 0x1F;  /* Ϊ԰ûʵʱʱоƬ,öʱ1ļʾ */
/*		adc = get_adc_data( ); */
		adc = ( (UINT16)TH0 << 8 ) | TL0;  /* Ϊ԰ûADC,öʱ0ļADCʾ */
		len = sprintf( mCmdParam.ByteWrite.mByteBuffer, "%02d.%02d.%02d ADC=%u\xd\xa", (UINT16)month, date, (UINT16)hour, adc );  /* ݸʽΪһַ */
		mCmdParam.ByteWrite.mByteCount = (unsigned char)len;  /* ָдֽ,ܳMAX_BYTE_IO,ûֶд */
		i = CH374ByteWrite( );  /* ֽΪλļд,ζдĳȲܳMAX_BYTE_IO */
		if ( i != ERR_SUCCESS ) return( i );
	}
/*	mCmdParam.ByteWrite.mByteCount = 0;  ָд0ֽ,ˢļĳ
	CH374ByteWrite( );  ֽΪλļд,Ϊ0ֽд,ֻڸļĳ,׶дݺ,ְ취ļ */
	printf( "Write end\n" );
	strcpy( mCmdParam.ByteWrite.mByteBuffer, "ADCݵ˽\xd\xa" );
	i = strlen( mCmdParam.ByteWrite.mByteBuffer );
	mCmdParam.ByteWrite.mByteCount = i;  /* ָдֽ,ζдĳȲܳMAX_BYTE_IO */
	i = CH374ByteWrite( );  /* ֽΪλļд,ζдĳȲܳMAX_BYTE_IO */
	if ( i != ERR_SUCCESS ) return( i );
/*	printf( "Modify\n" );  ʵʲƷʵʱʱ,ԸҪļںʱ޸Ϊʵֵ
	mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
	mCmdParam.Modify.mFileTime = MAKE_FILE_TIME( 16, 32, 09 );   : µļʱ: 16:32:09
	mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
	mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
	i = CH374FileModify( );   ޸ĵǰļϢ,޸
	if ( i != ERR_SUCCESS ) return( i );
*/
	printf( "Close\n" );
	mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
	i = CH374FileClose( );  /* رļ */
	if ( i != ERR_SUCCESS ) return( i );
	LED_WR_INACT( );
	LED_RUN_INACT( );
}

main( ) {
	UINT8	n, s;
	UINT8X	DiskPortNum;
	UINT16X	DiskTimer, MouseTimer;
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

	for ( n = 0; n < 3; n ++ ) RootHubDev[n].DeviceStatus = ROOT_DEV_DISCONNECT;  // 
	DiskTimer = 0;
	MouseTimer = 0;

	s = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( s );
	HostEnableRootHub( );  // õRoot-HUB

/* ·ʼ */
	while ( 1 ) {  // ѭ
		CH374DelaymS( 10 );  /* ûҪƵѯ,,ÿmSѯһ豸 */
		for ( n = 0; n < 3; n ++ ) {  // ROOT-HUB˿
			CH374vEmbHubIndex = n + 1;  // CH374LIBʹ1/2/3ֱ0/1/2HUB˿
			s = CH374EmbHubAttach( );  // 鵱ǰHUB˿ǷUSB豸
			if ( s == 0 ) {  // 豸Ͽ
				RootHubDev[n].DeviceStatus = ROOT_DEV_DISCONNECT;
				if ( RootHubDev[n].DeviceType == DEV_DISK ) CH374DiskStatus = DISK_DISCONNECT;  // ûU
			}
			else if ( s == BIT_HUB0_ATTACH	// USB豸δ
				|| s == ( BIT_HUB0_ATTACH & BIT_HUB0_EN ) && RootHubDev[n].DeviceStatus <= ROOT_DEV_CONNECTED ) {   // ֮ǰ豸߸ղ豸δʼ
				LED_OUT_ACT( );
				RootHubDev[n].DeviceStatus = ROOT_DEV_CONNECTED;
				CH374DelaymS( 200 );  // ȴUSB豸ϵȶ
				s = InitDevice( n );  // ʼ/öָHUB˿ڵUSB豸
				RootHubDev[n].DeviceType = s;  // 豸
				if ( s == DEV_DISK ) {  // Uöٳɹ
					DiskPortNum = n;  // UڵĶ˿ں
					printf( "Erase\n" );
					SelectHubPort( n );  // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
					strcpy( mCmdParam.Erase.mPathName, "/MY_ADC.TXT" );  /* ļ,ļڸĿ¼ */
					s = CH374FileErase( );  /* ɾļ */
					if ( s != ERR_SUCCESS && s != ERR_MISS_FILE ) {  /* ɾļʧܲļ */
						printf( "Erase file error %02X\n", (UINT16)s );
					}
					SetUsbSpeed( TRUE );  // ĬΪȫ,U̲ǵ,˲һ
				}
				else if ( s == DEV_HUB ) {  // HUBöٳɹ,οEVT\EMB_HUB\ROOTHUB.C
//					ʲô?  HUB˿ϵ,ѯ˿״̬,ʼ豸ӵHUB˿,ʼ豸
				}
				LED_OUT_INACT( );
			}
			else {};  // 豸һֱ,Ѿʼ
		}
		CH374DelaymS( 10 );  /* ûҪƵѯ,,ÿmSѯһ豸 */
		DiskTimer ++;
		if ( DiskTimer >= 1000 ) {  // ٶĳ͹ҪдU,˴üĳֵԼ20mS*100020ﵽĳһ
			while ( 1 ) {
				n = SearchHubPort( DEV_DISK );  // UڵĶ˿ں,ûмUڶ˿
				if ( n == DiskPortNum ) break;  // ȷʵһUöٵHUB˿ں(ļϵͳⱣһU̵״̬)
				if ( n == 0xFF ) break;  // ûҵ,豸Ͽ
				RootHubDev[n].DeviceStatus = ROOT_DEV_FAILED;  // һUöٵHUB˿ں,ö˿ڵUҪ·ļϵͳ
			}
			if ( n == DiskPortNum ) {  // ҵһUöٵHUB˿ں
				printf( "WriteFile to USB-Disk\n" );
				SelectHubPort( n );  // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
				s = CH374DiskReady( );  /* ѯǷ׼ */
				if ( s != ERR_DISK_DISCON ) {  /* ΪеUԶʧܶʵѾ,ֻжUǷϿ */
					s = WriteToDiskFile( );  // Uļ׷д,ӳEXAM7
					if ( s != ERR_SUCCESS ) {
						printf( "WriteFile error code = %02X\n", (UINT16)s );
					}
				}
				SetUsbSpeed( TRUE );  // ĬΪȫ,U̲ǵ,˲һ
				DiskTimer = 0;  // дU̺
			}
		}
// //ӡ,ʾMOUSE
		MouseTimer ++;
		if ( MouseTimer >= 500 ) {  // ٶҪÿ20mS*10200mSѯһ״̬,5
			n = SearchHubPort( DEV_MOUSE );  // MOUSEڵĶ˿ں,˿ںΪ0xFFδ
			if ( n != 0xFF ) {
				printf( "Query Mouse\n" );
				SelectHubPort( n );  // ѡָROOT-HUB˿,õǰUSBٶԼ豸USBַ
				s = GetDeviceDescr( TempBuf );  // ȡ豸
				if ( s == USB_INT_SUCCESS ) {
					for ( s = 0; s < ( (PUSB_SETUP_REQ)SetupGetDevDescr ) -> wLengthL; s ++ ) printf( "0x%02X ", (UINT16)( TempBuf[s] ) );
					printf( "\n" ); // ʾ
				}
//				CH374vUsbPidIn = TRUE;  /* IN */
//				CH374_WRITE_REGISTER( REG_USB_H_PID, M_MK_HOST_PID_ENDP( DEF_USB_PID_IN, RootHubDev[n].MOUSE.MouseInterruptEndp ) );  /* ָPIDĿĶ˵ */
//				CH374_WRITE_REGISTER( REG_USB_H_CTRL, RootHubDev[n].MOUSE.MouseIntEndpTog | BIT_HOST_START );  /* ͬ־ */
//				CH374vRetryCount &= 0x7F;  /* ʱֹNAKԶ,ΪûʱNAK,ֻǲѯɵ,ݾȡ,ûҲɵ */
//				s = CH374HostTransact( );  /*  */
//				CH374vRetryCount |= 0x80;  /* ָNAKԶ */
//				if ( s == ERR_SUCCESS ) {  /* ɹ */
//					CH374_READ_BLOCK( RAM_HOST_RECV, CH374_READ_REGISTER( REG_USB_LENGTH ), TempBuf );  /* ȡ */
//				}
				SetUsbSpeed( TRUE );  // ĬΪȫ
				MouseTimer = 0;  // ѯ
			}
		}
// ֶ֧༶ⲿHUB,ô˴ڲѯHUB˿״̬,ԼⲿHUB˿ϵ豸¼
	}
}
