/* 2004.06.05
****************************************
**  Copyright  (C)  W.ch  1999-2004   **
**  Web:  http://www.winchiphead.com  **
****************************************
**  USB Host File Interface for CH374 **
**  TC2.0@PC, IAR_C/EC++_2.10A@MSP430 **
****************************************
*/
/* CH374 ļϵͳӿ */
/* ֧: FAT12/FAT16/FAT32 */

/* MSP430ƬCԵUļдʾ, ھв600ֽRAMĵƬ */
/* óUе/C51/CH374HFT.Cļеǰ600ַʾ,
   ҲԭļCH374HFT.C, ôóʾC51Ŀ¼CH374ͷļ,
   ҲC51Ŀ¼, ôóʾĿ¼µļ,
   󽫳ROMеһַдд½ļ"NEWFILE.TXT"
*/
/* CH374INT#Ųòѯʽ, ݸƷʽΪ"ڲ", MSP430F449Ƭ, 0Ϣ,9600bps */

/* ֽΪλдUļ,дٶȽģʽ,ֽģʽдļҪļݻFILE_DATA_BUF,
   ֻܹҪ600ֽڵRAM,ڵƬӲԴޡСҶдٶҪ󲻸ߵϵͳ */


/* ICC430 CH374HFT.C -l CH374HFT.LST -o CH374HFT.R43 */
/* XLINK CH374HFT.R43 -o CH374HFT.TXT -Fmsp430_txt ..\430\lib\cl430f.r43 CH374HFF.R43 -f ..\430\config\lnk430F449.xcl */

#include <msp430x44x.h>
#include <stdio.h>
#include <string.h>

/* ¶ϸ˵뿴CH374HFF.Hļ */
#define LIB_CFG_INT_EN			0		/* CH374INT#ӷʽ,0Ϊ"ѯʽ",1Ϊ"жϷʽ" */

/* ƬRAM: 0200H-03FFHΪ̶д, ֽΪλдļҪļݶдFILE_DATA_BUF */
#define	DISK_BASE_BUF_ADDR		0x0200	/* ⲿRAMĴݻʼַ,ӸõԪʼĻΪSECTOR_SIZE */

#define CH374_INT_WIRE			( P1IN & 0x10 )	/* P1.4, CH374жINT#,CH374INT#,ڲѯж״̬ */
/* δCH374ж,ôӦȥ,ԶʹüĴѯʽ */

//#define DISK_BASE_BUF_LEN		2048	/* ĬϵĴݻСΪ512ֽ,ѡΪ20484096֧ĳЩU,Ϊ0ֹ.Hļж建ӦópDISK_BASE_BUFָ */
/* ҪôݻԽԼRAM,ôɽDISK_BASE_BUF_LENΪ0Խֹ.Hļж建,ӦóڵCH375Init֮ǰõĻʼַpDISK_BASE_BUF */

#define NO_DEFAULT_CH374_F_ENUM		1		/* δCH374FileEnumerʽֹԽԼ */
#define NO_DEFAULT_CH374_F_QUERY	1		/* δCH374FileQueryʽֹԽԼ */
#define NO_DEFAULT_CH374_RESET		1		/* δCH374ResetʽֹԽԼ */

#pragma language=extended
#include "..\CH374HFF.H"
#pragma language=default

/* MSP430ϵͳ,I/OģCH374Ĳڶдʱ */
/* еӲӷʽ(ʵӦõ·Բ޸3ڶдӳ) */
/* MSP430Ƭ    CH374оƬ
         P1.4                 INT#
         P1.3                 A0
         P1.2                 CS#
         P1.1                 WR#
         P1.0                 RD#
         P4(8λ˿)         D7-D0       */

void CH374_PORT_INIT( )  /* ʹͨI/Oģ鲢ڶдʱ,Խгʼ */
{
	P1OUT = ( P1OUT | 0x07 ) & 0xF7;  /* A0Ϊ͵ƽ,CS,WR,RDĬΪߵƽ */
	P1DIR = ( P1DIR | 0x0F ) & 0xEF;  /* INT#Ϊ,CS,WR,RD,A0Ϊ */
	P4DIR = 0;  /* 8λ */
}

void Write374Index( UINT8 mCmd )		/* ˿дַ */
{
	P1DIR |= 0x0F;  /* P1A0,CS,WR,RDΪź */
	P4OUT = mCmd;  /* CH374Ĳ */
	P4DIR = 0xFF;  /* д */
	P1OUT |= 0x0F;  /* ָCH374оƬ˿, A0(P1.3)=1; */
	P1OUT &= 0xF9;  /* Чдź, дCH374оƬ˿, A0(P1.3)=1; CS(P1.2)=0; WR=(P1.1)=0; RD(P1.0)=1; */
	_NOP( );  /* ò,ʱ,CH374ҪдΪ100nS */
	P1OUT |= 0x07;  /* ЧĿź, ɲCH374оƬ, A0(P1.3)=1; CS(P1.2)=1; WR=(P1.1)=1; RD(P1.0)=1; */
	P1OUT &= 0xF7;  /* A0(P1.3)=0; ѡ */
	P4DIR = 0;  /* ֹ */
}

void Write374Data( UINT8 mData )		/* ݶ˿д,ַԶ1 */
{
	P4OUT = mData;  /* CH374Ĳ */
	P4DIR = 0xFF;  /* д */
	P1OUT &= 0xF1;  /* Чдź, дCH374оƬݶ˿, A0(P1.3)=0; CS(P1.2)=0; WR=(P1.1)=0; RD(P1.0)=1; */
	_NOP( );  /* ò,ʱ,CH374ҪдΪ100nS */
	P1OUT |= 0x07;  /* ЧĿź, ɲCH374оƬ, A0(P1.3)=0; CS(P1.2)=1; WR=(P1.1)=1; RD(P1.0)=1; */
	P4DIR = 0;  /* ֹ */
}

UINT8 Read374Data( void )			/* ݶ˿ڶ,ַԶ1 */
{
	UINT8	mData;
	P4DIR = 0;  /*  */
	P1OUT &= 0xF2;  /* Чź, CH374оƬݶ˿, A0(P1.3)=0; CS(P1.2)=0; WR=(P1.1)=1; RD(P1.0)=0; */
	_NOP( );  /* ò,ʱ,CH374ҪдΪ100nS */
	mData = P4IN;  /* CH374Ĳ */
	P1OUT |= 0x07;  /* ЧĿź, ɲCH374оƬ, A0(P1.3)=0; CS(P1.2)=1; WR=(P1.1)=1; RD(P1.0)=1; */
	return( mData );
}

#include "PARA.C"	/* ʱ */
/*#include "SPI.C"*/    /* SPIʱ */

/* P1.7һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( )		{ P1DIR |= 0x80; }	/* P1.7 ߵƽΪ */
#define LED_OUT_ACT( )		{ P1OUT &= 0x7F; }	/* P1.7 ͵ƽLEDʾ */
#define LED_OUT_INACT( )	{ P1OUT |= 0x80; }	/* P1.7 ͵ƽLEDʾ */

/* ״̬,ʾ벢ͣ */
void	mStopIfError( UINT8 iError )
{
	if ( iError == ERR_SUCCESS ) return;  /* ɹ */
	printf( "Error: %02X\n", (UINT16)iError );  /* ʾ */
/* ,Ӧ÷ԼCH374DiskStatus״̬,CH374DiskConnectѯǰUǷ,UѶϿôµȴU̲ٲ,
   Ĵ:
   1һCH374DiskReady,ɹ,Open,Read/Write,CH374DiskReadyлԶCH374DiskConnect
   2CH374DiskReadyɹ,ôǿнCH374DiskStatusΪDISK_CONNECT״̬,Ȼͷʼ(ȴUCH374DiskConnectCH374DiskReady) */
	while ( 1 ) {
		LED_OUT_ACT( );  /* LED˸ */
		CH374DelaymS( 100 );
		LED_OUT_INACT( );
		CH374DelaymS( 100 );
	}
}

/* Ϊprintfgetkeyʼ */
void	mInitSTDIO( )
{
	UTCTL0 = SSEL1;                       // UCLK = SMCLK
	UBR00 = 0x41;                         // 7.99MHz 9600bps
	UBR10 = 0x03;                         // 7.99MHz 9600bps
	UMCTL0 = 0x00;                        // no modulation
	UCTL0 = CHAR;                         // 8-bit character *SWRST*
	ME1 |= UTXE0 + URXE0;                 // Enable USART0 TXD/RXD
	P2SEL |= 0x30;                        // P2.4,5 = USART0 TXD/RXD
	P2DIR |= 0x10;                        // P2.4 output direction
}

/* ͨϢ */
int		putchar( int c )
{
	while ( ( IFG1 & UTXIFG0 ) == 0 );    // USART0 TX buffer ready?
	TXBUF0 = c;                           // char to TXBUF0
	return( c );
}

/* ѡ8MHzʱ */
void	init_clk( )
{
	WDTCTL = WDTPW + WDTHOLD;       // stop watchdog timer
	SCFI0 |= FN_4;                  // x2 DCO frequency, 8MHz nominal DCO  
	SCFQCTL = 121;                  // (121+1) x 32768 x 2 = 7.99 Mhz
	FLL_CTL0 = DCOPLUS + XCAP18PF;  // DCO+ set so freq = xtal x D x N+1
}

main( ) {
	UINT8	i, c;
	UINT16	TotalCount;
	UINT8	*pCodeStr;
	init_clk( );
	CH374_PORT_INIT( );
	LED_OUT_INIT( );
	LED_OUT_ACT( );  /* LEDһʾ */
	CH374DelaymS( 100 );  /* ʱ100 */
	LED_OUT_INACT( );
	mInitSTDIO( );  /* Ϊüͨڼʾ */
	printf( "Start\n" );

#if DISK_BASE_BUF_LEN == 0
	pDISK_BASE_BUF = &my_buffer[0];  /* .HļжCH374רû,ûָָӦóĻںԽԼRAM */
#endif

	i = CH374LibInit( );  /* ʼCH374CH374оƬ,ɹ0 */
	mStopIfError( i );
/* ·ʼ */

	while ( 1 ) {
		printf( "Wait Udisk\n" );
		while ( 1 ) {  /* ֧USB-HUB,ӵĴοEXAM1EXAM13 */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) == ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_ACT( );  /* LED */
		CH374DelaymS( 200 );  /* ʱ,ѡ,еUSB洢Ҫʮʱ */

/* UǷ׼,ЩU̲Ҫһ,ĳЩU̱Ҫִһܹ */
		for ( i = 0; i < 5; i ++ ) {  /* еUǷδ׼,Ա */
			CH374DelaymS( 100 );
			printf( "Ready ?\n" );
			if ( CH374DiskReady( ) == ERR_SUCCESS ) break;  /* ѯǷ׼ */
		}
		if ( CH374DiskStatus <= DISK_CONNECT ) continue;  /* ֧USB-HUB */

/* ѯ */
/*		printf( "DiskSize\n" );
		i = CH374DiskSize( );  
		mStopIfError( i );
		printf( "TotalSize = %u MB \n", (unsigned int)( mCmdParam.DiskSize.mDiskSizeSec * ( CH374vSectorSize / 512 ) >> 11 ) );  ʾΪMBΪλ
*/

/* ȡԭļ */
		printf( "Open\n" );
		strcpy( (char *)mCmdParam.Open.mPathName, "/C51/CH374HFT.C" );  /* ļ,ļC51Ŀ¼ */
		i = CH374FileOpen( );  /* ļ */
		if ( i == ERR_MISS_DIR || i == ERR_MISS_FILE ) {  /* ûҵļ */
/* гļ */
			if ( i == ERR_MISS_DIR ) pCodeStr = "/*";  /* C51Ŀ¼гĿ¼µļ */
			else pCodeStr = "/C51/CH374*";  /* CH374HFT.Cļг\C51Ŀ¼µCH374ͷļ */
			printf( "List file %s\n", pCodeStr );
			for ( c = 0; c < 254; c ++ ) {  /* ǰ254ļ,Ҫ255ļοEXAM1EXAM0 */
				strcpy( (char *)mCmdParam.Open.mPathName, (char *)pCodeStr );  /* ļ,*Ϊͨ,ļĿ¼ */
/* һöٷǣ˴cΪ0xFFȻöŴCH374vFileSizeУӶ254ļ02147483647 */
				i = strlen( (char *)mCmdParam.Open.mPathName );
				mCmdParam.Open.mPathName[ i ] = c;  /* ַȽ滻Ϊ,0254 */
				i = CH374FileOpen( );  /* ļ,ļкͨ*,Ϊļ */
				if ( i == ERR_MISS_FILE ) break;  /* Ҳƥļ,Ѿûƥļ */
				if ( i == ERR_FOUND_NAME ) {  /* ͨƥļ,ļ· */
					printf( "  match file %03d#: %s\n", (unsigned int)c, mCmdParam.Open.mPathName );  /* ʾźƥļĿ¼ */
					continue;  /* һƥļ,´ʱŻ1 */
				}
				else {  /*  */
					mStopIfError( i );
					break;
				}
			}
		}
		else {  /* ҵļ߳ */
			mStopIfError( i );
			TotalCount = 600;  /* ׼ȡܳ */
			printf( "ļжǰ%dַ:\n",TotalCount );
			while ( TotalCount ) {  /* ļȽϴ,һζ,ٵCH374ByteReadȡ,ļָԶƶ */
				if ( TotalCount > MAX_BYTE_IO ) c = MAX_BYTE_IO;  /* ʣݽ϶,ƵζдĳȲܳ sizeof( mCmdParam.ByteRead.mByteBuffer ) */
				else c = TotalCount;  /* ʣֽ */
				mCmdParam.ByteRead.mByteCount = c;  /* ʮֽ */
				i = CH374ByteRead( );  /* ֽΪλȡݿ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵ */
				mStopIfError( i );
				TotalCount -= mCmdParam.ByteRead.mByteCount;  /* ,ȥǰʵѾַ */
				for ( i=0; i!=mCmdParam.ByteRead.mByteCount; i++ ) printf( "%C", mCmdParam.ByteRead.mByteBuffer[i] );  /* ʾַ */
				if ( mCmdParam.ByteRead.mByteCount < c ) {  /* ʵʶַҪַ,˵ѾļĽβ */
					printf( "\n" );
					printf( "ļѾ\n" );
					break;
				}
			}
/*	    ϣָλÿʼд,ƶļָ
		mCmdParam.ByteLocate.mByteOffset = 608;  ļǰ608ֽڿʼд
		CH374ByteLocate( );
		mCmdParam.ByteRead.mByteCount = 5;  ȡ5ֽ
		CH374ByteRead( );   ֱӶȡļĵ608ֽڵ612ֽ,ǰ608ֽڱ

	    ϣӵԭļβ,ƶļָ
		CH374FileOpen( );
		mCmdParam.ByteLocate.mByteOffset = 0xffffffff;  Ƶļβ
		CH374ByteLocate( );
		mCmdParam.ByteWrite.mByteCount = 13;  д13ֽڵ
		CH374ByteWrite( );   ԭļĺ,¼ӵ13ֽڽԭļβ
		mCmdParam.ByteWrite.mByteCount = 2;  д2ֽڵ
		CH374ByteWrite( );   ԭļĺ
		mCmdParam.ByteWrite.mByteCount = 0;  д0ֽڵ,ʵϸò֪ͨļ
		CH374ByteWrite( );   д0ֽڵ,Զļĳ,ļ15,,ôִCH374FileCloseʱҲԶļ
*/
			printf( "Close\n" );
			i = CH374FileClose( );  /* رļ */
			mStopIfError( i );
		}

#ifdef EN_DISK_WRITE  /* ӳ֧д */
/* ļ */
		printf( "Create\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/NEWFILE.TXT" );  /* ļ,ڸĿ¼,ļ */
		i = CH374FileCreate( );  /* ½ļ,ļѾɾ½ */
		mStopIfError( i );
		printf( "Write\n" );
		pCodeStr = "Note: \xd\xaֽΪλUļд,ƬֻҪ600ֽڵRAM\xd\xa";
		while( 1 ) {  /* ֶдļ */
			for ( i=0; i<MAX_BYTE_IO; i++ ) {
				c = *pCodeStr;
				mCmdParam.ByteWrite.mByteBuffer[i] = c;
				if ( c == 0 ) break;  /* Դַ */
				pCodeStr++;
			}
			if ( i == 0 ) break;  /* Դַ,дļ */
			mCmdParam.ByteWrite.mByteCount = i;  /* дݵַ,ζдĳȲܳMAX_BYTE_IO,ڶεʱŸղŵд */
			i = CH374ByteWrite( );  /* ļд */
			mStopIfError( i );
		}
/*		printf( "Modify\n" );
		mCmdParam.Modify.mFileAttr = 0xff;   : µļ,Ϊ0FFH޸
		mCmdParam.Modify.mFileTime = 0xffff;   : µļʱ,Ϊ0FFFFH޸,ʹ½ļĬʱ
		mCmdParam.Modify.mFileDate = MAKE_FILE_DATE( 2004, 5, 18 );  : µļ: 2004.05.18
		mCmdParam.Modify.mFileSize = 0xffffffff;   : µļ,ֽΪλдļӦɳرļʱԶ³,Դ˴޸
		i = CH374FileModify( );   ޸ĵǰļϢ,޸
		mStopIfError( i );
*/
		printf( "Close\n" );
		mCmdParam.Close.mUpdateLen = 1;  /* Զļ,ֽΪλдļ,óرļԱԶļ */
		i = CH374FileClose( );
		mStopIfError( i );

/* ɾĳļ */
/*		printf( "Erase\n" );
		strcpy( (char *)mCmdParam.Create.mPathName, "/OLD" );  ɾļ,ڸĿ¼
		i = CH374FileErase( );  ɾļر
		if ( i != ERR_SUCCESS ) printf( "Error: %02X\n", (UINT16)i );  ʾ
*/

/* ѯϢ */
/*		printf( "Disk\n" );
		i = CH374DiskQuery( );
		mStopIfError( i );
		printf( "Fat=%d, Total=%ld, Free=%ld\n", (UINT16)mCmdParam.Query.mDiskFat, mCmdParam.Query.mTotalSector, mCmdParam.Query.mFreeSector );
*/
#endif
		printf( "Take out\n" );
		while ( 1 ) {  /* ֧USB-HUB */
			CH374DelaymS( 10 );  /* ûҪƵѯ */
			if ( CH374DiskConnect( ) != ERR_SUCCESS ) break;  /* ѯʽ: ǷӲ´״̬,سɹ˵ */
		}
		LED_OUT_INACT( );  /* LED */
		CH374DelaymS( 200 );
	}
}
